var documenterSearchIndex = {"docs":
[{"location":"energy.html#Dynamic-Energy-Budgets","page":"Dynamic Energy Budgets","title":"Dynamic Energy Budgets","text":"","category":"section"},{"location":"energy.html","page":"Dynamic Energy Budgets","title":"Dynamic Energy Budgets","text":"NOTE: currently not used.","category":"page"},{"location":"energy.html","page":"Dynamic Energy Budgets","title":"Dynamic Energy Budgets","text":"Persefone's nature module uses Kooijman's Dynamic Energy Budget theory to model energy flows within individuals.","category":"page"},{"location":"energy.html","page":"Dynamic Energy Budgets","title":"Dynamic Energy Budgets","text":"(Image: \"The standard model of the Dynamic Energy Budget theory\")","category":"page"},{"location":"energy.html","page":"Dynamic Energy Budgets","title":"Dynamic Energy Budgets","text":"The standard model of the Dynamic Energy Budget theory. (Fig. 1 from Sousa et al. (2010).)","category":"page"},{"location":"energy.html","page":"Dynamic Energy Budgets","title":"Dynamic Energy Budgets","text":"Sousa et al. (2010). Dynamic energy budget theory restores coherence in biology. Philosophical Transactions of the Royal Society B: Biological Sciences, 365(1557), 3413–3428.\nKooijman, S. A. L. M. (2009). Dynamic energy and mass budgets in biological systems (3rd ed). Cambridge University Press.\nSibly et al. (2013). Representing the acquisition and use of energy by individuals in agent-based models of animal populations. Methods in Ecology and Evolution, 4(2), 151–161.","category":"page"},{"location":"energy.html#energy.jl","page":"Dynamic Energy Budgets","title":"energy.jl","text":"","category":"section"},{"location":"energy.html","page":"Dynamic Energy Budgets","title":"Dynamic Energy Budgets","text":"Modules = [Persefone]\nPages = [\"nature/energy.jl\"]","category":"page"},{"location":"energy.html#Persefone.DEBparameters","page":"Dynamic Energy Budgets","title":"Persefone.DEBparameters","text":"DEBparameters\n\nAn immutable struct to save the parameter list for a species' Dynamic Energy Budget model. (See Sousa et al., 2010.)\n\n\n\n\n\n","category":"type"},{"location":"energy.html#Persefone.EnergyBudget","page":"Dynamic Energy Budgets","title":"Persefone.EnergyBudget","text":"EnergyBudget\n\nThis struct represents an individual's energy balance, as conceptualised by the Dynamic Energy Budget theory. Upon assimilation, energy is first stored as biomass in a reserve buffer, before being used for maintenance, growth, and reproduction. (Note that this is a simplified model form which ignores maturity as a separate buffer.)\n\nSources:\n\nMalishev & Kramer-Schadt (2021). Movement, models, and metabolism: Individual-based energy budget models as next-generation extensions for predicting animal movement outcomes across scales. Ecological Modelling, 441, 109413. https://doi.org/10.1016/j.ecolmodel.2020.109413\nMarques et al. (2018). The AmP project: Comparing species on the basis of dynamic energy budget parameters. PLOS Computational Biology,14(5), e1006100. https://doi.org/10.1371/journal.pcbi.1006100\nSibly et al. (2013). Representing the acquisition and use of energy by individuals in agent-based models of animal populations. Methods in Ecology and Evolution, 4(2), 151–161. https://doi.org/10.1111/2041-210x.12002\nSousa et al. (2010). Dynamic energy budget theory restores coherence in biology. Philosophical Transactions of the Royal Society B: Biological Sciences, 365(1557), 3413–3428. https://doi.org/10.1098/rstb.2010.0166\nKooijman, S. A. L. M. (2009). Dynamic energy and mass budgets in biological systems (3rd ed). Cambridge University Press. https://www.researchgate.net/profile/Edgar-Meza-3/post/Isthereatoxicokineticmodelfordaphniamagnaorotherzooplankton/attachment/59d62cf579197b807798b396/AS%3A348547653357569%401460111644286/download/Dynamic+Energy+Budget+theory+-+Kooijman.pdf\ncompare with: Brown et al. (2004). Toward a metabolic theory of ecology. Ecology, 85(7), 1771–1789. https://doi.org/10.1890/03-9000\n\n\n\n\n\n","category":"type"},{"location":"energy.html#Persefone.feed!-Tuple{Float64, Persefone.EnergyBudget}","page":"Dynamic Energy Budgets","title":"Persefone.feed!","text":"feed!(quantity, energybudget)\n\nConsume a given quantity of food. Expands the energy reserve by an amount determined by the assimilation rate. Returns true if successful, false if the reserve is already full.\n\n\n\n\n\n","category":"method"},{"location":"energy.html#Persefone.growthrate-Tuple{Persefone.EnergyBudget}","page":"Dynamic Energy Budgets","title":"Persefone.growthrate","text":"growthrate(energybudget)\n\nCalculate the specific growth rate r. (Internal function.)\n\n\n\n\n\n","category":"method"},{"location":"energy.html#Persefone.investmentratio-Tuple{Persefone.EnergyBudget}","page":"Dynamic Energy Budgets","title":"Persefone.investmentratio","text":"investmentratio(energybudget)\n\nCalculate the investment ratio g. (Internal function.)\n\n\n\n\n\n","category":"method"},{"location":"energy.html#Persefone.maturitymaintenance-Tuple{Persefone.EnergyBudget}","page":"Dynamic Energy Budgets","title":"Persefone.maturitymaintenance","text":"maturitymaintenance(energybudget)\n\nCalculate the specific maturity maintenance k_J. (Internal function.)\n\n\n\n\n\n","category":"method"},{"location":"energy.html#Persefone.mobilisation-Tuple{Persefone.EnergyBudget}","page":"Dynamic Energy Budgets","title":"Persefone.mobilisation","text":"mobilisation(energybudget)\n\nCalculate the mobilisation rate J_EC. (Internal function.)\n\n\n\n\n\n","category":"method"},{"location":"energy.html#Persefone.reproduce!-Tuple{Persefone.EnergyBudget}","page":"Dynamic Energy Budgets","title":"Persefone.reproduce!","text":"reproduce!(energybudget)\n\nIf there is sufficient energy in the offspring buffer of an adult, produce an embryo/egg, reducing the parent energy in the process. Returns the embryo's energy budget, or nothing if the conditions are not met.\n\n\n\n\n\n","category":"method"},{"location":"energy.html#Persefone.scaledreservedensity-Tuple{Persefone.EnergyBudget}","page":"Dynamic Energy Budgets","title":"Persefone.scaledreservedensity","text":"scaledreservedensity(energybudget)\n\nCalculate the scaled reserve density e. (Internal function.)\n\n\n\n\n\n","category":"method"},{"location":"energy.html#Persefone.update!-Tuple{Persefone.EnergyBudget}","page":"Dynamic Energy Budgets","title":"Persefone.update!","text":"update!(energybudget)\n\nCarry out a daily update of the energy budget. Mobilises reserves and allocates these to maintenance (prioritised), growth, and reproduction.\n\nReturn true if the individual has enough energy to survive, or false if the reserve is empty and it starves.\n\n\n\n\n\n","category":"method"},{"location":"energy.html#Persefone.volumetriclength-Tuple{Persefone.EnergyBudget}","page":"Dynamic Energy Budgets","title":"Persefone.volumetriclength","text":"volumetriclength(energybudget)\n\nCalculate the structural length in cm based on an individual's weight (assuming a density of 1 g/cm³ to calculate volume, see Kooijman 2009).\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Nature-submodel","page":"Nature submodel","title":"Nature submodel","text":"","category":"section"},{"location":"nature.html#nature.jl","page":"Nature submodel","title":"nature.jl","text":"","category":"section"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"This file is responsible for managing the animal modules.","category":"page"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"Modules = [Persefone]\nPages = [\"nature/nature.jl\"]","category":"page"},{"location":"nature.html#Persefone.Animal","page":"Nature submodel","title":"Persefone.Animal","text":"Animal\n\nThis is the generic agent type for all animals. Individual species are created using the @species macro. In addition to user-defined, species-specific fields, all species contain the following fields:\n\nid An integer unique identifier for this individual.\nsex male, female, or hermaphrodite.\nparents The IDs of the individual's parents.\npos An (x, y) coordinate tuple.\nage The age of the individual in days.\nphase The update function to be called during the individual's current life phase.\nenergy A DEBparameters struct for calculating energy budgets.\noffspring A vector containing the IDs of an individual's children.\nterritory A vector of coordinates that comprise the individual's territory.\n\n\n\n\n\n","category":"type"},{"location":"nature.html#Persefone.animalid-Tuple{Animal}","page":"Nature submodel","title":"Persefone.animalid","text":"animalid(animal)\n\nA small utility function to return a string with the species name and ID of an animal.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.create!-Tuple{Animal, SimulationModel}","page":"Nature submodel","title":"Persefone.create!","text":"create!(animal, model)\n\nThe create! function is called for every individual at birth or at model initialisation. Species must use @create to define a species-specific method. This is the fall- back method, in case none is implemented for a species.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.initnature!-Tuple{SimulationModel}","page":"Nature submodel","title":"Persefone.initnature!","text":"initnature!(model)\n\nInitialise the model with all simulated animal populations.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.killallanimals!-Tuple{Any}","page":"Nature submodel","title":"Persefone.killallanimals!","text":"killallanimals!(model)\n\nRemove all animal individuals from the simulation.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.speciesof-Tuple{Union{Animal, Type}}","page":"Nature submodel","title":"Persefone.speciesof","text":"speciesof(animal)\n\nReturn the species name of this animal as a string.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.speciestype-Tuple{String}","page":"Nature submodel","title":"Persefone.speciestype","text":"speciestype(name)\n\nReturn the Type of this species.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.stepagent!-Tuple{Animal, SimulationModel}","page":"Nature submodel","title":"Persefone.stepagent!","text":"stepagent!(animal, model)\n\nUpdate an animal by one day, executing it's currently active phase function.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.updatenature!-Tuple{SimulationModel}","page":"Nature submodel","title":"Persefone.updatenature!","text":"updatenature!(model)\n\nRun processes that affect all animals.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#macros.jl","page":"Nature submodel","title":"macros.jl","text":"","category":"section"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"This file contains all the macros that can be used in the species DSL.","category":"page"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"Modules = [Persefone]\nPages = [\"nature/macros.jl\"]","category":"page"},{"location":"nature.html#Persefone.@animal-Tuple{Any}","page":"Nature submodel","title":"Persefone.@animal","text":"@animal(id)\n\nReturn the animal object associated with this ID number. This can only be used in a context where the model object is available (e.g. nested within @phase).\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@countanimals-Tuple","page":"Nature submodel","title":"Persefone.@countanimals","text":"@countanimals(radius=0, species=\"\")\n\nCount the number of animals at or near this location, optionally filtering by species. This can only be used nested within @phase or @habitat.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@create-Tuple{Any, Any}","page":"Nature submodel","title":"Persefone.@create","text":"@create(species, body)\n\nDefine a special phase function (create!()) that will be called when an individual of this species is created, at the initialisation of the simulation or at birth.\n\nAs for @phase, the body of this macro has access to the variables self (the individual being created) and model (the simulation world), and can thus use all macros available in @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@cropcover-Tuple{}","page":"Nature submodel","title":"Persefone.@cropcover","text":"@cropcover\n\nReturn the percentage ground cover of the crop at this position, or nothing if there is no crop here. This is a utility wrapper that can only be used nested within @phase or @habitat.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@cropheight-Tuple{}","page":"Nature submodel","title":"Persefone.@cropheight","text":"@cropheight\n\nReturn the height of the crop at this position, or nothing if there is no crop here. This is a utility wrapper that can only be used nested within @phase or @habitat.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@cropname-Tuple{}","page":"Nature submodel","title":"Persefone.@cropname","text":"@cropname\n\nReturn the name of the local croptype, or an empty string if there is no crop here. This is a utility wrapper that can only be used nested within @phase or @habitat.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@destroynest-Tuple{Any}","page":"Nature submodel","title":"Persefone.@destroynest","text":"@destroynest(reason)\n\nUtility wrapper for destroynest!() in the Skylark model.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@directionto-Tuple{Any}","page":"Nature submodel","title":"Persefone.@directionto","text":"@directionto\n\nCalculate the direction to an animal or the closest habitat of the specified type or descriptor. This is a utility wrapper that can only be used nested within @phase or @habitat.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@distanceto-Tuple{Any}","page":"Nature submodel","title":"Persefone.@distanceto","text":"@distanceto\n\nCalculate the distance to an animal or the closest habitat of the specified type or descriptor. This is a utility wrapper that can only be used nested within @phase or @habitat.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@distancetoedge-Tuple{}","page":"Nature submodel","title":"Persefone.@distancetoedge","text":"@distancetoedge\n\nCalculate the distance to the closest neighbouring habitat. This is a utility wrapper that can only be used nested within @phase or @habitat.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@follow-Tuple{Any, Any}","page":"Nature submodel","title":"Persefone.@follow","text":"@follow(leader, distance)\n\nMove to a location within the given distance of the leading animal. This is a utility wrapper that can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@habitat-Tuple{Any}","page":"Nature submodel","title":"Persefone.@habitat","text":"@habitat\n\nSpecify habitat suitability for spatial ecological processes.\n\nThis macro works by creating an anonymous function that takes in a model object and a position, and returns true or false depending on the conditions specified in the macro body.\n\nSeveral utility macros can be used within the body of @habitat as a short-hand for common expressions: @landcover, @cropname, @cropheight, @distanceto, @distancetoedge, @countanimals. The variables model and pos can be used for checks that don't have a macro available.\n\nTwo example uses of @habitat might look like this:\n\nmovementhabitat = @habitat(@landcover() in (grass agriculture soil))\n\nnestinghabitat = @habitat((@landcover() == grass || \n                           (@landcover() == agriculture && @cropname() != \"maize\" &&\n                            @cropheight() < 10)) &&\n                          @distanceto(forest) > 20)\n\nFor more complex habitat suitability checks, the use of this macro can be circumvented by directly creating an equivalent function.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@here-Tuple{}","page":"Nature submodel","title":"Persefone.@here","text":"@here()\n\nReturn the landscape pixel of this animal's current location. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@isalive-Tuple{Any}","page":"Nature submodel","title":"Persefone.@isalive","text":"@isalive(id)\n\nTest whether the animal with the given ID is still alive. This can only be used in a context where the model object is available (e.g. nested within @phase).\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@isoccupied-Tuple{Any}","page":"Nature submodel","title":"Persefone.@isoccupied","text":"@isoccupied(position)\n\nTest whether this position is already occupied by an animal of this species. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@kill-Tuple","page":"Nature submodel","title":"Persefone.@kill","text":"@kill\n\nKill this animal (and immediately abort its current update if it dies). This is a thin wrapper around kill!, and passes on any arguments. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@killother-Tuple{Any, Vararg{Any}}","page":"Nature submodel","title":"Persefone.@killother","text":"@killother\n\nKill another animal. This is a thin wrapper around kill!, and passes on any arguments. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@landcover-Tuple{}","page":"Nature submodel","title":"Persefone.@landcover","text":"@landcover\n\nReturns the local landcover. This is a utility wrapper that can only be used nested within @phase or @habitat.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@lastyear-Tuple{Any}","page":"Nature submodel","title":"Persefone.@lastyear","text":"@lastyear(annualdate)\n\nConstruct a date object referring to the last year in the model from an AnnualDate. Only use in scopes where model is available.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@migrate-Tuple{Any}","page":"Nature submodel","title":"Persefone.@migrate","text":"@migrate(arrival)\n\nRemove this animal from the map and add it to the migrant species pool. It will be returned to its current location at the specified arrival date. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@move-Tuple{Any}","page":"Nature submodel","title":"Persefone.@move","text":"@move(position)\n\nMove the current individual to a new position. This is a utility wrapper that can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@nearby_animals-Tuple","page":"Nature submodel","title":"Persefone.@nearby_animals","text":"@nearby_animals(radius=0, species=\"\")\n\nReturn an iterator over all animals in the given radius around the current position. This can only be used nested within @phase or @habitat.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@neighbours-Tuple","page":"Nature submodel","title":"Persefone.@neighbours","text":"@neighbours(radius=0, conspecifics=true)\n\nReturn an iterator over all (by default conspecific) animals in the given radius around this animal, excluding itself. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@nextyear-Tuple{Any}","page":"Nature submodel","title":"Persefone.@nextyear","text":"@nextyear(annualdate)\n\nConstruct a date object referring to the next year in the model from an AnnualDate. Only use in scopes where model is available.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@occupy-Tuple{Any}","page":"Nature submodel","title":"Persefone.@occupy","text":"@occupy(position)\n\nAdd the given position to this animal's territory. Use @vacate to remove positions from the territory again. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@phase-Tuple{Any, Any, Any}","page":"Nature submodel","title":"Persefone.@phase","text":"@phase(name, body)\n\nUse this macro to describe a species' behaviour during a given phase of its life. The idea behind this is that species show very different behaviour at different times of their lives. Therefore, @phase can be used define the behaviour for one such phase, and the conditions under which the animal transitions to another phase.\n\n@phase works by creating a function that will be called by the model if the animal is in the relevant phase. When it is called, it has access to the following variables:\n\nself a reference to the animal itself. This provides access to all the variables   defined in the @species definition, as well as all standard Animal   variables (e.g. self.age, self.sex, self.offspring).\npos gives the animal's current position as a coordinate tuple.\nmodel a reference to the model world (an object of type SimulationModel).   This allows access, amongst others, to model.date (the current simulation date)   and model.landscape (a two-dimensional array of pixels containing geographic   information).\n\nMany macros are available to make the code within the body of @phase more succinct. Some of the most important of these are: @setphase, @respond, @kill, @reproduce, @neighbours, @migrate, @move, @occupy, @rand.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@populate-Tuple{Any, Any}","page":"Nature submodel","title":"Persefone.@populate","text":"@populate(species, params)\n\nSet the parameters that are used to initialise this species' population. For parameter options, see PopInitParams.\n\n@populate <species> begin\n    <parameter> = <value>\n    ...\nend \n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@randomdirection-Tuple","page":"Nature submodel","title":"Persefone.@randomdirection","text":"@randomdirection(range=1)\n\nReturn a random direction tuple that can be passed to @walk. This is a utility wrapper that can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@randompixel-Tuple","page":"Nature submodel","title":"Persefone.@randompixel","text":"@randompixel(range, habitatdescriptor)\n\nFind a random pixel within a given range of the animal's location that matches the habitatdescriptor (create this using @habitat). This is a utility wrapper that can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@reproduce-Tuple","page":"Nature submodel","title":"Persefone.@reproduce","text":"@reproduce\n\nLet this animal reproduce. This is a thin wrapper around reproduce!, and passes on any arguments. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@respond-Tuple{Any, Any}","page":"Nature submodel","title":"Persefone.@respond","text":"@respond(eventname, body)\n\nDefine how an animal responds to a landscape event that affects its current position. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@setphase-Tuple{Any}","page":"Nature submodel","title":"Persefone.@setphase","text":"@setphase(newphase)\n\nSwitch this animal over to a different phase. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@species-Tuple{Any, Any}","page":"Nature submodel","title":"Persefone.@species","text":"@species(name, body)\n\nA macro used to add new species types to the nature model. Use this to define species-specific variables and parameters.\n\nThe macro works by creating a keyword-defined mutable struct that contains the standard fields described for the Animal type, as well as any new fields that the user adds:\n\n@species <name> begin\n    <var1> = <value>\n    <var2> = <value>\n    ...\nend\n\nTo complete the species definition, the @phase, @create, and @populate macros also need to be used.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@thisyear-Tuple{Any}","page":"Nature submodel","title":"Persefone.@thisyear","text":"@thisyear(annualdate)\n\nConstruct a date object referring to the current model year from an AnnualDate. Only use in scopes where model is available.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@vacate-Tuple{Any}","page":"Nature submodel","title":"Persefone.@vacate","text":"@vacate(position)\n\nRemove the given position from this animal's territory. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@vacate-Tuple{}","page":"Nature submodel","title":"Persefone.@vacate","text":"@vacate()\n\nRemove this animal's complete territory. This can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#Persefone.@walk-Tuple","page":"Nature submodel","title":"Persefone.@walk","text":"@walk(direction, speed)\n\nWalk the animal in a given direction, which is specified by a tuple of coordinates relative to the animal's current position (i.e. (2, -3) increments the X coordinate by 2 and decrements the Y coordinate by 3.) This is a utility wrapper that can only be used nested within @phase.\n\n\n\n\n\n","category":"macro"},{"location":"nature.html#individuals.jl","page":"Nature submodel","title":"individuals.jl","text":"","category":"section"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"This file contains life-history and other ecological functions that apply to all animal individuals, such reproduction, death, and movement.","category":"page"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"Modules = [Persefone]\nPages = [\"nature/individuals.jl\"]","category":"page"},{"location":"nature.html#Persefone.followanimal!","page":"Nature submodel","title":"Persefone.followanimal!","text":"followanimal!(follower, leader, model, distance=0)\n\nMove the follower animal to a location near the leading animal.\n\n\n\n\n\n","category":"function"},{"location":"nature.html#Persefone.kill!","page":"Nature submodel","title":"Persefone.kill!","text":"kill!(animal, model, probability=1.0, cause=\"\")\n\nKill this animal, optionally with a given percentage probability. Returns true if the animal dies, false if not.\n\n\n\n\n\n","category":"function"},{"location":"nature.html#Persefone.migrate!-Tuple{Animal, SimulationModel, AnnualDate}","page":"Nature submodel","title":"Persefone.migrate!","text":"migrate!(animal, model, arrival)\n\nRemove this animal from the map and add it to the migrant species pool. It will be returned to its current location at the specified arrival date.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.move!-Tuple{Animal, SimulationModel, Tuple{Int64, Int64}}","page":"Nature submodel","title":"Persefone.move!","text":"move!(animal, model, position)\n\nMove the animal to the given position, making sure that this is in-bounds. If the position is out of bounds, the animal stops at the map edge.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.occupy!-Tuple{Animal, SimulationModel, Tuple{Int64, Int64}}","page":"Nature submodel","title":"Persefone.occupy!","text":"occupy!(animal, model, position)\n\nAdd the given location to the animal's territory. Returns true if successful (i.e. if the location was not already occupied by a conspecific), false if not.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.reproduce!","page":"Nature submodel","title":"Persefone.reproduce!","text":"reproduce!(animal, model, mate, n=1)\n\nProduce one or more offspring for the given animal at its current location. The mate argument gives the ID of the reproductive partner.\n\n\n\n\n\n","category":"function"},{"location":"nature.html#Persefone.vacate!-Tuple{Animal, SimulationModel, Tuple{Int64, Int64}}","page":"Nature submodel","title":"Persefone.vacate!","text":"vacate!(animal, model, position)\n\nRemove this position from the animal's territory.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.vacate!-Tuple{Animal, SimulationModel}","page":"Nature submodel","title":"Persefone.vacate!","text":"vacate!(animal, model)\n\nRemove the animal's complete territory.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.walk!","page":"Nature submodel","title":"Persefone.walk!","text":"walk!(animal, model, direction, distance=1pixel)\n\nLet the animal move a given number of steps in the given direction (\"north\", \"northeast\", \"east\", \"southeast\", \"south\", \"southwest\", \"west\", \"northwest\", \"random\").\n\n\n\n\n\n","category":"function"},{"location":"nature.html#Persefone.walk!-2","page":"Nature submodel","title":"Persefone.walk!","text":"walk!(animal, model, direction, distance=-1)\n\nLet the animal move in the given direction, where the direction is defined by an (x, y) tuple to specify the shift in coordinates. If maxdist >= 0, move no further than the specified distance.\n\n\n\n\n\n","category":"function"},{"location":"nature.html#populations.jl","page":"Nature submodel","title":"populations.jl","text":"","category":"section"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"This file contains functions that apply to all animal populations, such as for initialisation, or querying for neighbours.","category":"page"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"Modules = [Persefone]\nPages = [\"nature/populations.jl\"]","category":"page"},{"location":"nature.html#Persefone.PopInitParams","page":"Nature submodel","title":"Persefone.PopInitParams","text":"PopInitParams\n\nA set of parameters used by initpopulation! to initialise the population of a species at the start of a simulation. Define these parameters for each species using @populate.\n\ninitphase determines which life phase individuals will be assigned to at model   initialisation (required).\nbirthphase determines which life phase individuals will be assigned to at birth (required).\nhabitat is a function that determines whether a given location is suitable   or not (create this using @habitat). By default, every cell will be occupied.\npopsize determines the number of individuals that will be created, dispersed over the   suitable locations in the landscape. If this is zero or negative, one individual will   be created in every suitable location. If it is greater than the number of suitable   locations, multiple individuals will be created per location. Alternately, use indarea.\nindarea: if this is greater than zero, it determines the habitat area allocated to each   individual or pair. To be precise, the chance of creating an individual (or pair of   individuals) at a suitable location is 1/indarea. Use this as an alternative to popsize.\nIf pairs is true, a male and a female individual will be created in each selected   location, otherwise, only one individual will be created at a time. (default: false)\nIf asexual is true, all created individuals are assigned the sex hermaphrodite,   otherwise, they are randomly assigned male or female. If pairs is true, asexual   is ignored. (default: false)\n\n\n\n\n\n","category":"type"},{"location":"nature.html#Persefone.countanimals-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Nature submodel","title":"Persefone.countanimals","text":"countanimals(pos, model; radius=0, species=\"\")\n\nReturn the number of animals in the given radius around this position, optionally filtering by species.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.directionto-Tuple{Tuple{Int64, Int64}, SimulationModel, Animal}","page":"Nature submodel","title":"Persefone.directionto","text":"directionto(pos, model, animal)\n\nCalculate the direction from the given position to the animal.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.distanceto-Tuple{Tuple{Int64, Int64}, SimulationModel, Animal}","page":"Nature submodel","title":"Persefone.distanceto","text":"distanceto(pos, model, animal)\n\nCalculate the distance from the given position to the animal.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.initindividuals!-Tuple{Type, Tuple{Int64, Int64}, Persefone.PopInitParams, SimulationModel}","page":"Nature submodel","title":"Persefone.initindividuals!","text":"initindividuals!(species, pos, popinitparams, model)\n\nInitialise one or two individuals (depending on the pairs parameter) in the given location. Returns the number of created individuals. (Internal helper function for initpopulation!().)\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.initpopulation!-Tuple{String, SimulationModel}","page":"Nature submodel","title":"Persefone.initpopulation!","text":"initpopulation!(speciesname, model)\n\nInitialise the population of the given species, based on the parameters stored in PopInitParams. Define these using @populate.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.initpopulation!-Tuple{Type, Persefone.PopInitParams, SimulationModel}","page":"Nature submodel","title":"Persefone.initpopulation!","text":"initpopulation!(speciestype, popinitparams, model)\n\nInitialise the population of the given species, based on the given initialisation parameters. This is an internal function called by initpopulation!(), and was split off from it to allow better testing.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.isalive-Tuple{Int64, SimulationModel}","page":"Nature submodel","title":"Persefone.isalive","text":"isalive(id, model)\n\nTest whether the animal with the given ID is still alive.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.isoccupied-Tuple{SimulationModel, String, Tuple{Int64, Int64}}","page":"Nature submodel","title":"Persefone.isoccupied","text":"isoccupied(model, position, species)\n\nTest whether this location is part of the territory of an animal of the given species.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.nearby_animals-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Nature submodel","title":"Persefone.nearby_animals","text":"nearby_animals(pos, model; radius= 0, species=\"\")\n\nReturn a list of animals in the given radius around this position, optionally filtering by species.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.nearby_ids-Tuple{Tuple{Int64, Int64}, SimulationModel, Union{Unitful.Quantity{T, 𝐋, U}, Unitful.Level{L, S, Unitful.Quantity{T, 𝐋, U}} where {L, S}} where {T, U}}","page":"Nature submodel","title":"Persefone.nearby_ids","text":"nearby_ids(pos, model, radius)\n\nReturn a list of IDs of the animals within a given radius of the position.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.neighbours","page":"Nature submodel","title":"Persefone.neighbours","text":"neighbours(animal, model, radius=0, conspecifics=true)\n\nReturn a list of animals in the given radius around this animal, excluding itself. By default, only return conspecific animals.\n\n\n\n\n\n","category":"function"},{"location":"nature.html#Persefone.populationparameters-Tuple{Type}","page":"Nature submodel","title":"Persefone.populationparameters","text":"populationparameters(type)\n\nA function that returns a PopInitParams object for the given species type. Parametric methods for each species are defined with @populate. This is the catch-all method, which throws an error if no species-specific function is defined.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.territorysize","page":"Nature submodel","title":"Persefone.territorysize","text":"territorysize(animal, model, stripunits=false)\n\nCalculate the size of this animal's territory in the given unit. If stripunits is true, return the size as a plain number.\n\n\n\n\n\n","category":"function"},{"location":"nature.html#ecologicaldata.jl","page":"Nature submodel","title":"ecologicaldata.jl","text":"","category":"section"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"This file contains a set of life-history related utility functions needed by species.","category":"page"},{"location":"nature.html","page":"Nature submodel","title":"Nature submodel","text":"Modules = [Persefone]\nPages = [\"nature/ecologicaldata.jl\"]","category":"page"},{"location":"nature.html#Persefone.initecologicaldata-Tuple{SimulationModel}","page":"Nature submodel","title":"Persefone.initecologicaldata","text":"initecologicaldata()\n\nCreate output files for each data group collected by the nature model.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.saveindividualdata-Tuple{SimulationModel}","page":"Nature submodel","title":"Persefone.saveindividualdata","text":"saveindividualdata(model)\n\nReturn a data table (to be printed to individuals.csv), listing all properties of all animal individuals in the model. May be called never, daily, monthly, yearly, or at the end of a simulation, depending on the parameter nature.indoutfreq. WARNING: Produces very big files!\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.savepopulationdata-Tuple{SimulationModel}","page":"Nature submodel","title":"Persefone.savepopulationdata","text":"savepopulationdata(model)\n\nReturn a data table (to be printed to populations.csv), giving the current date and population size for each animal species. May be called never, daily, monthly, yearly, or at the end of a simulation, depending on the parameter nature.popoutfreq.\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.skylarkabundance-Tuple{SimulationModel}","page":"Nature submodel","title":"Persefone.skylarkabundance","text":"skylarkabundance(model)\n\nSave skylark abundance data, including total abundance and demographic data (abundances of breeding/non-breeding/juvenile/migrated individuals).\n\n\n\n\n\n","category":"method"},{"location":"nature.html#Persefone.skylarkterritories-Tuple{SimulationModel}","page":"Nature submodel","title":"Persefone.skylarkterritories","text":"skylarkterritories(model)\n\nReturn a list of all coordinates occupied by a skylark territory, and the ID of the individual holding the territory. WARNING: produces very big files.\n\n\n\n\n\n","category":"method"},{"location":"gui.html#Graphical-User-Interface","page":"Graphical User Interface","title":"Graphical User Interface","text":"","category":"section"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Due to the computational demands of simulating many individuals at high temporal and spatial resolution, Persefone.jl is primarily designed to be run non-interactively on an HPC. However, to allow interactive exploratory simulations to be conducted while learning or developing the model, a graphical user interface is available as an additional package: Persefone Desktop.","category":"page"},{"location":"gui.html#Quick-start","page":"Graphical User Interface","title":"Quick start","text":"","category":"section"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Follow these instructions if you simply want to try out the software as a user. If you want to play around with the source code, see the next section.","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Download the Julia programming language and install it on ","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"your computer.","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Start Julia. This should launch a commandline interface/REPL.\nExecute the following commands (copy-and-paste should work):","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"using Pkg\nPkg.add(url=\"https://git.idiv.de/persefone/persefone-model.git\")\nPkg.add(url=\"https://git.idiv.de/persefone/persefone-desktop.git\")\nusing PersefoneDesktop\nENV[\"QSG_RENDER_LOOP\"] = \"basic\" # only needed on Windows\nlaunch()","category":"page"},{"location":"gui.html#Running-from-the-repo","page":"Graphical User Interface","title":"Running from the repo","text":"","category":"section"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Follow these instructions if you want to get to grips with the source code. For more detailed installation instructions, see here.","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"To install: Install Julia and download/clone  the repository. Open a Julia REPL  in the downloaded folder and execute the following to install all dependencies:","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"using Pkg\nPkg.activate(\".\")\nPkg.instantiate()","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"To run: Run desktop.jl. Alternatively, open a Julia REPL in this folder and run:","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"using Pkg\nPkg.activate(\".\")\nusing PersefoneDesktop\nlaunch()","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Note: Due to the necessary pre-compilation done by Julia, installing and launching the application can take quite a long time. (Start-up time with desktop.jl is currently about 2 minutes.) We will reduce this as much as possible in future releases.","category":"page"},{"location":"gui.html#User-interface","page":"Graphical User Interface","title":"User interface","text":"","category":"section"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"(Image: Persefone.jl Desktop screenshot)","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"The main window component is the map view. This displays a land cover map of the simulated region: dark green are forests, light green grassland, yellow fields, red built-up areas and blue water. On it, little circles show the position of individual animals, with different species denoted by different colours.","category":"page"},{"location":"gui.html#Control-bar","page":"Graphical User Interface","title":"Control bar","text":"","category":"section"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Back button: Rewind the simulation by one day.\nStep button: Advance the simulation by one day.\nRun button: Run the simulation until the button is pressed again or the end date is reached.\nProgress bar: Shows the percentage of time elapsed between the start and end dates of the simulation.\nSpeed slider: Set the time delay between each simulation step when running.\nDate: Shows the simulation date currently displayed on the map.","category":"page"},{"location":"gui.html#Menu-bar","page":"Graphical User Interface","title":"Menu bar","text":"","category":"section"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Simulation:","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"New simulation: Reset the model and start over.\nConfigure simulation: Change the model settings (not yet implemented).\nLoad saved state: Load a model object file saved by a previous simulation run.\nSave current state: Save a model object file for later use.\nQuit: Close the application.","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Data:","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Show population graph: Show a window with a graph of population sizes over time in the current model run.\nSave simulation output: Save the model output data to file (saves both raw CSV data and generated graphics).","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Help:","category":"page"},{"location":"gui.html","page":"Graphical User Interface","title":"Graphical User Interface","text":"Documentation: Open the Persefone.jl online documentation in a browser.\nWebsite: Open the main Persefone.jl website in a browser.\nAbout: Show a window with core information about the application.","category":"page"},{"location":"io.html#Input-and-Output","page":"Input and Output","title":"Input and Output","text":"","category":"section"},{"location":"io.html","page":"Input and Output","title":"Input and Output","text":"These functions are responsible for reading in all model configurations (passed by config file or commandline), administrating them during a run, and printing or plotting any output.","category":"page"},{"location":"io.html#input.jl","page":"Input and Output","title":"input.jl","text":"","category":"section"},{"location":"io.html","page":"Input and Output","title":"Input and Output","text":"Modules = [Persefone]\nPages = [\"core/input.jl\"]","category":"page"},{"location":"io.html#Persefone.AVAILABLE_CROPMODELS","page":"Input and Output","title":"Persefone.AVAILABLE_CROPMODELS","text":"The crop models that can be used in the simulation.\n\n\n\n\n\n","category":"constant"},{"location":"io.html#Persefone.PARAMFILE","page":"Input and Output","title":"Persefone.PARAMFILE","text":"The file that stores all default parameters: src/parameters.toml\n\n\n\n\n\n","category":"constant"},{"location":"io.html#Persefone.flattenTOML-Tuple{Any}","page":"Input and Output","title":"Persefone.flattenTOML","text":"flattenTOML(dict)\n\nAn internal utility function to convert the two-dimensional dict returned by TOML.parsefile() into a one-dimensional dict, so that instead of writing settings[\"domain\"][\"param\"] one can use settings[\"domain.param\"]. Can be reversed with prepareTOML.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.getsettings","page":"Input and Output","title":"Persefone.getsettings","text":"getsettings(configfile, userparams=Dict())\n\nCombines all configuration options to produce a single settings dict. Precedence: function arguments - commandline parameters - user config file - default values\n\n\n\n\n\n","category":"function"},{"location":"io.html#Persefone.loadmodelobject-Tuple{String}","page":"Input and Output","title":"Persefone.loadmodelobject","text":"loadmodelobject(fullfilename)\n\nDeserialise a model object that was previously saved with [savemodelobject](@ref).\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.parsecommandline-Tuple{}","page":"Input and Output","title":"Persefone.parsecommandline","text":"parsecommandline()\n\nCertain software parameters can be set via the commandline.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.preprocessparameters-Tuple{Dict{String, Any}, String}","page":"Input and Output","title":"Persefone.preprocessparameters","text":"preprocessparameters(settings)\n\nTake the raw input parameters and process them where necessary (e.g. convert types or perform checks). This is a helper function for getsettings.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.@param-Tuple{Any}","page":"Input and Output","title":"Persefone.@param","text":"@param(domainparam)\n\nReturn a configuration parameter from the global settings. The argument should be in the form <domain>.<parameter>, for example @param(core.outdir). Possible values for <domain> are core, nature, farm, or crop. For a full list of parameters, see src/parameters.toml.\n\nNote: this macro only works in a context where the model object is available!\n\n\n\n\n\n","category":"macro"},{"location":"io.html#output.jl","page":"Input and Output","title":"output.jl","text":"","category":"section"},{"location":"io.html","page":"Input and Output","title":"Input and Output","text":"Modules = [Persefone]\nPages = [\"core/output.jl\"]","category":"page"},{"location":"io.html#Persefone.LOGFILE","page":"Input and Output","title":"Persefone.LOGFILE","text":"Log output is saved to simulation.log in the output directory\n\n\n\n\n\n","category":"constant"},{"location":"io.html#Persefone.RECORDDIR","page":"Input and Output","title":"Persefone.RECORDDIR","text":"All input data are copied to the inputs folder within the output directory\n\n\n\n\n\n","category":"constant"},{"location":"io.html#Persefone.DataOutput","page":"Input and Output","title":"Persefone.DataOutput","text":"DataOutput\n\nA struct for organising model output. This is used to collect model data in an in-memory dataframe or for CSV output. Submodels can register their own output functions using newdataoutput!.\n\nStruct fields:     - frequency: how often to call the output function (daily/monthly/yearly/end/never)     - databuffer: a vector of vectors that temporarily saves data before it is stored permanently or written to file     - datastore: a data frame that stores data until the end of the run     - outputfunction: a function that takes a model object and returns data values to record (formatted as a vector of vectors)     - plotfunction: a function that takes a model object and returns a Makie figure object (optional)\n\n\n\n\n\n","category":"type"},{"location":"io.html#Persefone.createdatadir-Tuple{String, Union{Bool, String}}","page":"Input and Output","title":"Persefone.createdatadir","text":"createdatadir(outdir, overwrite)\n\nCreates the output directory, dealing with possible conflicts.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.data-Tuple{DataOutput}","page":"Input and Output","title":"Persefone.data","text":"Retrieve the data stored in a DataOutput (assumes core.storedata is true).\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.modellogger","page":"Input and Output","title":"Persefone.modellogger","text":"modellogger(loglevel, outdir, output=\"both\")\n\nCreate a logger object that writes output to screen and/or a logfile. This object is stored as model.logger and can then be used with with_logger(). Note: requires createdatadir to be run first.\n\n\n\n\n\n","category":"function"},{"location":"io.html#Persefone.newdataoutput!","page":"Input and Output","title":"Persefone.newdataoutput!","text":"newdataoutput!(model, name, header, frequency, outputfunction, plotfunction)\n\nCreate and register a new data output. This function must be called by all submodels that want to have their output functions called regularly.\n\n\n\n\n\n","category":"function"},{"location":"io.html#Persefone.outputdata","page":"Input and Output","title":"Persefone.outputdata","text":"outputdata(model, force=false)\n\nCycle through all registered data outputs and activate them according to their configured frequency. If force is true, activate all outputs regardless of their configuration.\n\n\n\n\n\n","category":"function"},{"location":"io.html#Persefone.prepareTOML-Tuple{Any}","page":"Input and Output","title":"Persefone.prepareTOML","text":"prepareTOML(dict)\n\nAn internal utility function to re-convert the one-dimensional dict created by flattenTOML into the two-dimensional dict needed by TOML.print, and convert any data types into TOML-compatible types where necessary.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.record!-Tuple{SimulationModel, String, Vector}","page":"Input and Output","title":"Persefone.record!","text":"record!(model, outputname, data)\n\nAppend an observation vector to the given output.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.saveinputfiles-Tuple{SimulationModel}","page":"Input and Output","title":"Persefone.saveinputfiles","text":"saveinputfiles(model)\n\nCopy all input files into the output directory, including the actual parameter settings used. This allows replicating a run in future.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.savemodelobject-Tuple{SimulationModel, String}","page":"Input and Output","title":"Persefone.savemodelobject","text":"savemodelobject(model, filename)\n\nSerialise a model object and save it to file for later reference. Includes the current model and Julia versions for compatibility checking.\n\nWARNING: produces large files (>100 MB) and takes a while to execute.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.visualiseoutput-Tuple{SimulationModel}","page":"Input and Output","title":"Persefone.visualiseoutput","text":"visualiseoutput(model)\n\nCycle through all data outputs and call their respective plot functions, saving each figure to file.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.withtestlogger-Tuple{SimulationModel}","page":"Input and Output","title":"Persefone.withtestlogger","text":"withtestlogger(model)\n\nReplace the model logger with the currently active logger. This is intended to be used in the testsuite to circumvent a Julia issue, where @test_logs doesn't work with local loggers.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.@data-Tuple{Any}","page":"Input and Output","title":"Persefone.@data","text":"@data(outputname)\n\nReturn the data stored in the given output (assumes core.storedata is true). Only use in scopes where model is available.\n\n\n\n\n\n","category":"macro"},{"location":"io.html#Persefone.@record-Tuple","page":"Input and Output","title":"Persefone.@record","text":"@record(outputname, data)\n\nRecord an observation / data point. Only use in scopes where model is available.\n\n\n\n\n\n","category":"macro"},{"location":"io.html#makieplots.jl","page":"Input and Output","title":"makieplots.jl","text":"","category":"section"},{"location":"io.html","page":"Input and Output","title":"Input and Output","text":"Modules = [Persefone]\nPages = [\"analysis/makieplots.jl\"]","category":"page"},{"location":"io.html#Persefone.croptrends-Tuple{SimulationModel}","page":"Input and Output","title":"Persefone.croptrends","text":"croptrends(model)\n\nPlot a dual line graph of cropped area and average plant height per crop over time. Returns a Makie figure object.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.datetickmarks-Tuple{Any}","page":"Input and Output","title":"Persefone.datetickmarks","text":"datetickmarks(dates)\n\nGiven a vector of dates, construct a selection to use as tick mark locations. Helper function for [populationtrends](@ref)\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.populationtrends-Tuple{SimulationModel}","page":"Input and Output","title":"Persefone.populationtrends","text":"populationtrends(model)\n\nPlot a line graph of population sizes of each species over time. Returns a Makie figure object.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.skylarkpopulation-Tuple{SimulationModel}","page":"Input and Output","title":"Persefone.skylarkpopulation","text":"skylarkpopulation(model)\n\nPlot a line graph of total population size and individual demographics of skylarks over time. Returns a Makie figure object.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.skylarkstats-Tuple{SimulationModel}","page":"Input and Output","title":"Persefone.skylarkstats","text":"skylarkstats(model)\n\nPlot various statistics from the skylark model: nesting habitat, territory size, mortality.\n\n\n\n\n\n","category":"method"},{"location":"io.html#Persefone.visualisemap","page":"Input and Output","title":"Persefone.visualisemap","text":"visualisemap(model, date, landcover)\n\nDraw the model's land cover map and plot all individuals as points on it at the specified date. If no date is passed, use the last date for which data are available. Optionally, you can pass a landcover map image (this is needed to reduce the frequency of disk I/O for Persefone Desktop). Returns a Makie figure object.\n\n\n\n\n\n","category":"function"},{"location":"config.html#Configuration","page":"Configuration","title":"Configuration","text":"","category":"section"},{"location":"config.html","page":"Configuration","title":"Configuration","text":"Persefone requires three input files: a configuration file and two map files.  How to generate the map files is documented elsewhere. The configuration file defines parameter values and looks like this (see src/parameters.toml for the default):","category":"page"},{"location":"config.html","page":"Configuration","title":"Configuration","text":"### Persefone.jl - a model of agricultural landscapes and ecosystems in Europe.\n###\n### This is the default configuration file for Persefone, containing all model parameters.\n### The syntax is described here: https://toml.io/en/\n\n[core]\nconfigfile = \"src/parameters.toml\" # location of the configuration file\noutdir = \"results\" # location and name of the output folder\noverwrite = \"ask\" # overwrite the output directory? (true/false/\"ask\")\nlogoutput = \"both\" # log output to screen/file/both\ncsvoutput = true # save collected data in CSV files\nvisualise = true # generate result graphs\nstoredata = true # keep collected data in memory\nloglevel = \"debug\" # verbosity level: \"debug\", \"info\", \"warn\"\nprocessors = 2 # number of processors to use on parallel runs\nseed = 2 # seed value for the RNG (0 -> random value)\nstartdate = 2022-01-01 # first day of the simulation\nenddate = 2022-12-31 # last day of the simulation\n\n[world]\nlandcovermap = \"data/regions/jena/landcover.tif\" # location of the landcover map\nfarmfieldsmap = \"data/regions/jena/fields.tif\" # location of the field geometry map\nweatherfile = \"data/regions/jena/weather.csv\" # location of the weather data file\n\t\n[farm]\nfarmmodel = \"FieldManager\" # which version of the farm model to use (not yet implemented)\n\n[nature]\ntargetspecies = [\"Wolpertinger\", \"Wyvern\"] # list of target species to simulate\npopoutfreq = \"daily\" # output frequency population-level data, daily/monthly/yearly/end/never\nindoutfreq = \"end\" # output frequency individual-level data, daily/monthly/yearly/end/never\ninsectmodel = [\"season\", \"habitat\", \"pesticides\", \"weather\"] # factors affecting insect growth\n\t\n[crop]\ncropmodel = \"almass\" # crop growth model to use, \"almass\" or \"aquacrop\"\ncropfile = \"data/crops/almass/crop_data_general.csv\" # file with general crop parameters\ngrowthfile = \"data/crops/almass/almass_crop_growth_curves.csv\" # file with crop growth parameters\t","category":"page"},{"location":"config.html","page":"Configuration","title":"Configuration","text":"info: Parameter scanning\nYou can set any parameter to a list of different values, e.g. seed = [1,2,3]. Persefone will then set up and run multiple simulations, one for every possible combination of parameters that you entered (i.e. do a full-factorial simulation experiment).","category":"page"},{"location":"using.html#The-Persefone.jl-Package","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"","category":"section"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"This page describes how to run Persefone.jl as a command line application or Julia package, which is the default mode. To use the model with a graphical user interface, see here.","category":"page"},{"location":"using.html#Installation","page":"The Persefone.jl Package","title":"Installation","text":"","category":"section"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"For more detailed installation instructions, see here.","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"Install the latest version of the Julia programming  language (1.10+). The recommended editors are VSCode or Emacs. To install the package dependencies, open a Julia REPL in this folder and run:","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"using Pkg\nPkg.activate(\".\")\nPkg.instantiate()","category":"page"},{"location":"using.html#Running-from-the-command-line","page":"The Persefone.jl Package","title":"Running from the command line","text":"","category":"section"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"This is the normal mode of operation. Simply execute run.jl in a terminal, typically like  so (in Linux):","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"> julia run.jl -c <config>","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"where <config> specifies the configuration file to use. The recommended workflow is to copy scr/parameters.toml to a location of your choice and edit the copy to suit your requirements. The adapted config file can then be passed to run.jl. (If no configuration file is specified, Persefone will run with its default settings.)","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"The full list of commandline arguments is:","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"usage: run.jl [-c CONFIGFILE] [-s SEED] [-o OUTDIR] [-l LOGLEVEL] \n              [--version] [-h]\n\noptional arguments:\n  -c, --configfile CONFIGFILE\n                        name of the configuration file\n  -s, --seed SEED       inital random seed (type: Int64)\n  -o, --outdir OUTDIR   location of the output directory\n  -l, --loglevel LOGLEVEL\n                        verbosity: \"debug\", \"info\", or \"quiet\"\n  --version             show version information and exit\n  -h, --help            show this help message and exit","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"To run the test suite, switch to the test directory and execute runtests.jl.","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"If you are on Linux or MacOS, you can also use make:","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"> make run       # run a simulation with default values\n> make test      # run the test suite\n> make profile   # run and profile a default simulation\n> make docs      # build the documentation\n> make release   # create a release","category":"page"},{"location":"using.html#Running-from-within-Julia","page":"The Persefone.jl Package","title":"Running from within Julia","text":"","category":"section"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"To use the model from within Julia (either inside an interactive REPL or if you want to import it from your own software), do the following:","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"using Pkg\nPkg.activate(\".\") # assuming you're in the Persefone root folder\nusing Persefone","category":"page"},{"location":"using.html","page":"The Persefone.jl Package","title":"The Persefone.jl Package","text":"You can then access all Persefone functions, such as simulate, initialise, stepsimulation!, simulate!, or visualiseoutput. (See src/Persefone.jl for a list of exported  functions.)","category":"page"},{"location":"architecture.html#Source-code-architecture","page":"Source code architecture","title":"Source code architecture","text":"","category":"section"},{"location":"architecture.html#Model-components","page":"Source code architecture","title":"Model components","text":"","category":"section"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"(Image: \"model architecture\")","category":"page"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"Persefone is divided into four components, three of which are semi-independent submodels:","category":"page"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"core and world: These two directories provide the foundation of the model software,  which sets up and executes simulation runs. It also reads all input files (the configuration  file, landscape maps, and weather data), and provides data output functionality.\nnature: This is an individual-based model of species in agricultural landscapes. It defines the Animal agent type, and a set of macros that can be used to rapidly create new species. It also includes ecological process functions that are useful for all species.\nfarm: This is an agent-based model of farmer decision making. It is not yet implemented, but will provide the Farmer agent type.\ncrop: This is a mathematical growth model for various crops. It is not yet implemented, but already provides the agent type FarmPlot, representing one field and its associated extent and crop type.","category":"page"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"Conceptually, core provides functionality that is needed by all of the submodels. Decisions made by Farmers affect the FarmPlots they own, and (directly or indirectly) the Animals in the model landscape.","category":"page"},{"location":"architecture.html#Important-implementation-details","page":"Source code architecture","title":"Important implementation details","text":"","category":"section"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"(Image: \"the model object\")","category":"page"},{"location":"architecture.html#The-model-object","page":"Source code architecture","title":"The model object","text":"","category":"section"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"A cursory reading of the source code will quickly show that most functions take an  SimulationModel object as one of their arguments. The concrete type for this is AgricultureModel, a struct that holds all state that is in any way relevant  to a simulation run. (Persefone has a strict \"no global state\" policy to avoid  state-dependent bugs and allow parallelisation.) The model object gives access to all  agent instances. It also stores the configuration (model.settings), the landscape (model.landscape, a matrix of Pixel objects that store the local land cover, amongst other things), and the current simulation date (model.date). (See Persefone.initmodel for details.)","category":"page"},{"location":"architecture.html#Model-configuration/the-@param-macro","page":"Source code architecture","title":"Model configuration/the @param macro","text":"","category":"section"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"The model is configured via a TOML file, the default version of which is at  src/parameters.toml. An individual run can be configured using a user-defined configuration file, commandline arguments, or function calls (when Persefone is used as a package rather than an application). During a model run, the @param macro can be used to access parameter values.  Note that parameter names are prepended with the name of the component they are associated  with. For example, the outdir parameter belongs to the [core] section of the TOML file,  and must therefore be referenced as  @param(core.outdir). (See  src/core/input.jl  for details.)","category":"page"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"info: @param and other macros\nAs @param(parameter) expands to model.settings[\"parameter\"], it can obviously only be used in a context where the model object is actually available. (This is the case for most functions in Persefone, but not for all.) Similarly, many of the nature macros depend on specific variables being available where they are called, and can therefore only be used in specific contexts (this is indicated in their documentation).","category":"page"},{"location":"architecture.html#Output-data","page":"Source code architecture","title":"Output data","text":"","category":"section"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"Persefone can output model data into text files with a specified frequency (daily, monthly, yearly, or at the simulation end). Submodels can use Persefone.newdataoutput! to plug into this system. For an example of how to use  this, see src/nature/ecologicaldata.jl.  (See src/core/output.jl for details.)","category":"page"},{"location":"architecture.html#Farm-events","page":"Source code architecture","title":"Farm events","text":"","category":"section"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"The FarmEvent struct is used to communicate farming-related events between  submodels. An event can be triggered with createevent! and affects all pixels  within a FarmPlot. (See  src/core/landscape.jl  for details.)","category":"page"},{"location":"architecture.html#Random-numbers-and-logging","page":"Source code architecture","title":"Random numbers and logging","text":"","category":"section"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"By default in Julia, the random number generator (RNG) and the system logger are two globally accessible variables. As Persefone needs to avoid all global data (since this would interfere with reproducibility in parallel runs), the model object stores a  local logger and a local RNG. The local logger generally does not change the way the  model uses log statements, it is  only relevant for some functions in src/core/simulation.jl.","category":"page"},{"location":"architecture.html","page":"Source code architecture","title":"Source code architecture","text":"info: Using the model RNG\nWhenever you need to use a random number,  you must use the model.rng. The easiest way to do this is with the @rand  and @shuffle! macros. (Note that these, too, require access to the model object.)","category":"page"},{"location":"skylark.html#Skylark","page":"Skylark","title":"Skylark","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"Alauda arvensis is a common and charismatic species of agricultural landscapes. This animal model is one component of the nature submodel of Persefone.jl.","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The  model  description follows  the  ODD  (Overview,  Design  concepts, Details)  protocol  (Grimm  et  al.,  2006; 2010; 2020):","category":"page"},{"location":"skylark.html#1.-Purpose","page":"Skylark","title":"1. Purpose","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The purpose of this animal model is to simulate the abundance and distribution of a population of Alauda arvensis in response to farm management in Central European agricultural landscapes.","category":"page"},{"location":"skylark.html#2.-Entities,-state-variables,-and-scales","page":"Skylark","title":"2. Entities, state variables, and scales","text":"","category":"section"},{"location":"skylark.html#2.1-Landscape","page":"Skylark","title":"2.1 Landscape","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The simulated landscape consists of a grid of pixels with a resolution of 10m and can have an extent of 20km²-200km² (approximately; depending on the chosen input map). Each pixel is assigned a land cover class. It may also be associated with a farm plot, in which case it will contain information about the type and growth stage of the crop planted here. Farm management determines which crops are grown when, and  when disturbance (e.g. mowing, harvesting, tillage) takes place.","category":"page"},{"location":"skylark.html#2.2-Animals","page":"Skylark","title":"2.2 Animals","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The simulated individuals (a.k.a. agents) are mature skylarks. Each skylark  is characterised by the following variables:","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"ID A unique identifier for this individual, which can be used to link it to its parents and its offspring.\nsex Male or female.\nphase The individual's current stage in the annual/life cycle. May be one of: migration,  nonbreeding, territorysearch, occupation, matesearch, nesting, breeding.\nposition The individual's position in the simulated landscape.\nmate The ID of the individual with which this individual has mated this year, if any.\nterritory A list of coordinates of the positions in the landscape that this individual claims as its nesting and feeding territory.\nnest A coordinate giving the location of the currently active nest.\nclutch The number of juvenile (i.e. not yet independent) skylarks that this individual is currently raising.","category":"page"},{"location":"skylark.html#3.-Process-overview-and-scheduling","page":"Skylark","title":"3. Process overview and scheduling","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The simulation proceeds in time steps of one day. Every day, each individual executes the function associated with their current life phase:","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"migration: The individual is held in a separate data structure (apart from the model landscape) and does nothing until its return date is reached. Then, it is re-introduced to the landscape and assigned the phase territorysearch (for males) or matesearch (for females).\nterritorysearch: Males return first from migration. If they already have a territory from a previous year, they return to this. Otherwise, they move randomly through the landscape until they find a contiguous territory that satisfies their habitat requirements. Once a male has a territory, it changes its phase to occupation.\nmatesearch: Females return later than males from their winter migration. If they already had a partner the previous year, they have a given probability of remaining with this partner. Otherwise, they move randomly through the landscape, looking for a male with a territory and without a partner. Once the female has a partner, it changes its phase to nesting.","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"If an individual fails to find a territory or a mate, it changes its phase to nonbreeding once the breeding season is over.","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"occupation: The male moves at random about its territory until the breeding season is over. Then it changes its phase to nonbreeding. (Note: Skylark males actively help with feeding their chicks. However, feeding is only modelled indirectly here, through the process of habitat selection when the male forms its territory - see section 4.1.)\nnesting: The female selects a suitable location within the male's territory for the nest. Building the nest and laying eggs takes a number of days, during which she does nothing else. Then, she changes her phase to breeding.\nbreeding: The female checks for mortality. The probability of brood loss varies with the age of the clutch and the nesting habitat. If and when the chicks reach independence (30 days after hatching), they are instantiated as new individuals in the nonbreeding phase.","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"If a nest fails due to predation or disturbance, or a brood leaves the nest successfully, the female resets her phase to nesting and begins again if the breeding season is not yet over. If it is, she changes her phase to nonbreeding.","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"nonbreeding: Non-breeding mature birds move randomly around the landscape, keeping close to other individuals (flocking behaviour). Once their individual migration date is reached, they are removed from the landscape until the following year (see above). Mature birds have a mortality probability for their first summer, and others thereafter for each winter.","category":"page"},{"location":"skylark.html#4.-Design-concepts","page":"Skylark","title":"4. Design concepts","text":"","category":"section"},{"location":"skylark.html#4.1-Basic-principles","page":"Skylark","title":"4.1 Basic principles","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"This model assumes that the two most important drivers of skylark distribution and abundance are habitat availability and juvenile mortality (see literature below). The factors  and processes affecting these are therefore given the most attention in the model, while other  factors and processes are only included superficially, indirectly, or not at all. Specifically,  this means that the phases territorysearch, nesting, and breeding are the most relevant  and detailed parts of the model, as these determine the selection of habitat and the survival of  offspring.","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"Furthermore, the model concentrates on predation and anthropogenic disturbance (through management actions such as mowing) as the main causes of juvenile mortality. Other causes, such as hunger or bad weather, are currently ignored as they are usually not significant.","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The focus on habitat availability and juvenile mortality opens up two avenues by which agricultural management influences skylark populations. First, the farmers' choice of crops and date of sowing determines the quality of the habitat when skylarks select a territory. (For example, unlike summer grain, winter grain is already so high and dense in spring that it is generally avoided for nesting.) Secondly, the frequency and timing of management actions (especially mowing) is a major cause of brood loss. This means that there are direct causal links between agriculture and population trends.","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"Concentrating on these two drivers allows the rest of the model to be kept simple, reducing both the scientific complexity and computational costs. Thus, foraging movement (both during and after the breeding season) can be ignored or represented as random movement, as it does not directly impact either of the drivers. Likewise, chick growth and winter migration are represented very simply.","category":"page"},{"location":"skylark.html#4.2-Emergence","page":"Skylark","title":"4.2 Emergence","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"Multiple patterns emerge from the basic principles outlined above. The most important are listed here:","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"Territory size and population density: The model assumes that skylarks occupy only as much area as they need to satisfy their nesting and foraging requirements, and that population size is limited by the amount of available habitat. This means that territories in high-quality habitat  are smaller than in low-quality habitat. Scaling up, this leads to a pattern whereby population  densities are highest in open landscapes with a diversity of crops, grassland, semi-natural habitat, and lower in landscapes with low habitat diversity or many woody features.\nEcological traps: Jenny (1990) describes a strong ecological trap effect whereby skylarks avoid winter grain crops, preferentially nesting in more open grassland sites. However, the mowing frequency associated with modern agriculture means that nest loss in grassland is almost assured, since there is insufficient time between two mowing dates to raise a brood. This means that landscape composition leads skylarks to breed in habitats that have a high mortality, resulting in population declines.","category":"page"},{"location":"skylark.html#4.3-Adaptation","page":"Skylark","title":"4.3 Adaptation","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"In the model, skylarks primarily adapt to their surroundings by choosing suitable territories. These are chosen by evaluating the quality of surrounding habitats for breeding and foraging,  and occupying as much area as needed to satisfy requirements (see section 7.1).","category":"page"},{"location":"skylark.html#4.4-Objectives","page":"Skylark","title":"4.4 Objectives","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"Skylarks' main objective in the model is to have sufficient habitat available to raise a brood. Habitat quality is calculated as a function of habitat type, vegetation height, vegetation cover, and distance to vertical structures (see section 7.1).","category":"page"},{"location":"skylark.html#4.5-Learning","page":"Skylark","title":"4.5 Learning","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The model includes no learning by individuals.","category":"page"},{"location":"skylark.html#4.6-Prediction","page":"Skylark","title":"4.6 Prediction","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The model includes no predictions by individuals.","category":"page"},{"location":"skylark.html#4.7-Sensing","page":"Skylark","title":"4.7 Sensing","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"Skylarks can perceive the landscape structure in a given radius around them (habitat type, vegetation height and cover). They can also see nearby conspecifics and are aware of the territories claimed by other individuals. When mating, they recognise whether another individual already has a mate, and mated individuals share information about their territory and brood status.","category":"page"},{"location":"skylark.html#4.8-Interaction","page":"Skylark","title":"4.8 Interaction","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The model includes two direct forms of interaction. First, during mating, females move around the landscape looking for males who have a territory but no mate yet. Once they have found one, the two individuals set each other as their mate. Secondly, after the breeding seasons, individuals move around the landscape, keeping close to other individuals in their vicinity (flocking behaviour).","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"There are also indirect interactions, in that there is a competition for habitat (territory that has been claimed by one male cannot be occupied by another) and males (males that have mated with one female will not mate with another in the same season).","category":"page"},{"location":"skylark.html#4.9-Stochasticity","page":"Skylark","title":"4.9 Stochasticity","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"Stochasticity is used when modelling mortality and movement. Predation mortality is modelled as an  age- and habitat-dependent probability, while migration mortality is a simple probability. Dispersal  movement (when searching for a territory or a mate) is modelled as a random walk, as it is assumed  that skylarks are not significantly impeded in their long-range movement by habitats that are  unsuitable for foraging or nesting. Foraging movement by the male and by non-breeding individuals is  also random, as it is desirable to show movement (to help model analysis) but unimportant to model  this exactly.","category":"page"},{"location":"skylark.html#4.10-Collectives","page":"Skylark","title":"4.10 Collectives","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"After the breeding season, skylarks move around in loose agglomerations (flocking behaviour). However, this has no relevant ecological effect.","category":"page"},{"location":"skylark.html#4.11-Observation","page":"Skylark","title":"4.11 Observation","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"TODO","category":"page"},{"location":"skylark.html#5.-Initialisation","page":"Skylark","title":"5. Initialisation","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"At the beginning of a model run, pairs of skylarks are created on grassland and agricultural land, keeping a distance of 60m to vertical structures and allowing each pair approximately 3ha of suitable habitat (an average territory size in agricultural landscapes).","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"For details, see the source code and the associated documentation.","category":"page"},{"location":"skylark.html#6.-Input-data","page":"Skylark","title":"6. Input data","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The general input to Persefone (i.e. land use maps and weather data) is described here.","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"The following extract from the source code lists the species parameters and values used by the Skylark model, based on the literature cited below:","category":"page"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"@species Skylark begin\n    const movementrange::Length = 500m #XXX arbitrary\n    const visionrange::Length = 200m #XXX arbitrary\n    \n    const eggtime::Int64 = 11 # days from laying to hatching\n    const nestlingtime::Int64 = 9 # days from hatching to leaving nest\n    const fledglingtime::Int64 = 21 # days from leaving the nest to independence\n\n    #XXX predation mortality should be habitat-dependent\n    const eggpredationmortality::Float64 = 0.03 # per-day egg mortality from predation\n    const nestlingpredationmortality::Float64 = 0.03 # per-day nestling mortality from predation\n    const fledglingpredationmortality::Float64 = 0.01 # per-day fledgling mortality from predation\n    const firstyearmortality::Float64 = 0.38 # total mortality in the first year after independence\n    const migrationmortality::Float64 = 0.33 # chance of dying during the winter\n\n    const minimumterritory = 5000m² # size of territory under ideal conditions\n    const mindistancetoedge = 60m # minimum distance of habitat to vertical structures\n    const maxforageheight = 50cm # maximum preferred vegetation height for foraging\n    const maxforagecover = 0.7 # maximum preferred vegetation cover for foraging\n    const nestingheight = (15cm, 25cm) # min and max preferred vegetation height for nesting\n    const nestingcover = (0.2, 0.5) # min and max preferred vegetation cover for nesting\n\n    const matefaithfulness = 0.5 # chance of a female retaining her previous partner\n    const nestingbegin::Tuple{Int64,Int64} = (April, 10) # begin nesting in the middle of April\n    const nestbuildingtime::UnitRange{Int64} = 4:5 # 4-5 days needed to build a nest (doubled for first nest)\n    const eggsperclutch::UnitRange{Int64} = 2:5 # eggs laid per clutch\n    const nestingend::Int64 = July # last month of nesting\nend","category":"page"},{"location":"skylark.html#7.-Submodels","page":"Skylark","title":"7. Submodels","text":"","category":"section"},{"location":"skylark.html#7.1-Territory-formation","page":"Skylark","title":"7.1 Territory formation","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"TODO","category":"page"},{"location":"skylark.html#7.2-Juvenile-mortality","page":"Skylark","title":"7.2 Juvenile mortality","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"TODO","category":"page"},{"location":"skylark.html#8.-References","page":"Skylark","title":"8. References","text":"","category":"section"},{"location":"skylark.html","page":"Skylark","title":"Skylark","text":"Bauer, H.-G., Bezzel, E., & Fiedler, W. (Eds.). (2012). Das Kompendium der Vögel Mitteleuropas: Ein umfassendes Handbuch zu Biologie, Gefährdung und Schutz (Einbändige Sonderausg. der 2., vollständig überarb. und erw. Aufl. 2005). AULA-Verlag\nDelius, J. D. (1965). A Population Study of Skylarks Alauda Arvensis. Ibis, 107(4), 466–492.\nDonald et al. (2002). Survival rates, causes of failure and productivity of Skylark Alauda arvensis nests on lowland farmland.  Ibis, 144(4), 652–664.\nGlutz von Blotzheim, Urs N. (Ed.). (1985). Handbuch der Vögel Mitteleuropas. Bd. 10. Passeriformes (Teil 1) 1. Alaudidae - Hirundidae. AULA-Verlag, Wiesbaden. ISBN 3-89104-019-9\nJenny, M. (1990). Territorialität und Brutbiologie der Feldlerche Alauda arvensis in einer intensiv genutzten Agrarlandschaft. Journal für Ornithologie, 131(3), 241–265.\nJeromin, K. (2002). Zur Ernährungsökologie der Feldlerche (Alauda arvensis L. 1758)  in der Reproduktionsphase [Doctoral thesis].  Christian-Albrechts-Universität zu Kiel.\nPüttmanns et al. (2022). Habitat use and foraging parameters of breeding Skylarks indicate no seasonal decrease in food availability in heterogeneous farmland. Ecology and Evolution, 12(1), e8461.","category":"page"},{"location":"species.html#Species-models","page":"Species models","title":"Species models","text":"","category":"section"},{"location":"species.html","page":"Species models","title":"Species models","text":"The ecological submodel in Persefone simulates a range of species in agricultural landscapes.","category":"page"},{"location":"species.html#Skylark","page":"Species models","title":"Skylark","text":"","category":"section"},{"location":"species.html","page":"Species models","title":"Species models","text":"Modules = [Persefone]\nPages = [\"nature/species/skylark.jl\"]","category":"page"},{"location":"species.html#Persefone.Skylark","page":"Species models","title":"Persefone.Skylark","text":"Skylark\n\nAlauda arvensis is a common and charismatic species of agricultural landscapes.\n\nSources:     - Bauer, H.-G., Bezzel, E., & Fiedler, W. (Eds.). (2012). Das Kompendium       der Vögel Mitteleuropas: Ein umfassendes Handbuch zu Biologie, Gefährdung       und Schutz (Einbändige Sonderausg. der 2., vollständig überarb. und erw.       Aufl. 2005). AULA-Verlag     - Delius, J. D. (1965). A Population Study of Skylarks Alauda Arvensis.       Ibis, 107(4), 466–492. https://doi.org/10.1111/j.1474-919X.1965.tb07332.x     - Donald et al. (2002). Survival rates, causes of failure and productivity       of Skylark Alauda arvensis nests on lowland farmland. Ibis, 144(4), 652–664.       https://doi.org/10.1046/j.1474-919X.2002.00101.x     - Glutz von Blotzheim, Urs N. (Ed.). (1985). Handbuch der Vögel Mitteleuropas.       Bd. 10. Passeriformes (Teil 1) 1. Alaudidae - Hirundidae. AULA-Verlag, Wiesbaden.       ISBN 3-89104-019-9     - Jenny, M. (1990). Territorialität und Brutbiologie der Feldlerche Alauda       arvensis in einer intensiv genutzten Agrarlandschaft. Journal für Ornithologie,       131(3), 241–265. https://doi.org/10.1007/BF01640998     - Püttmanns et al. (2022). Habitat use and foraging parameters of breeding Skylarks       indicate no seasonal decrease in food availability in heterogeneous farmland.       Ecology and Evolution, 12(1), e8461. https://doi.org/10.1002/ece3.8461\n\n\n\n\n\n","category":"type"},{"location":"species.html#Persefone.#1218#fun","page":"Species models","title":"Persefone.#1218#fun","text":"Initialise the skylark population. Creates pairs of skylarks on grassland and agricultural land, keeping a distance of 60m to vertical structures and giving each pair an area of 3ha.\n\n\n\n\n\n","category":"function"},{"location":"species.html#Persefone.allowsnesting-Tuple{Persefone.Skylark, SimulationModel, Tuple{Int64, Int64}}","page":"Species models","title":"Persefone.allowsnesting","text":"allowsnesting(skylark, model, pos)\n\nCheck whether the given position is suitable for nesting.\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.breeding-Tuple{Persefone.Skylark, SimulationModel}","page":"Species models","title":"Persefone.breeding","text":"Females that have laid eggs take care of their chicks, restarting the nesting process once the chicks are independent or in case of brood loss.\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.create!-Tuple{Persefone.Skylark, SimulationModel}","page":"Species models","title":"Persefone.create!","text":"Initialise a skylark individual. Selects migration dates and checks if the bird should currently be on migration. Also sets other individual-specific variables.\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.destroynest!-Tuple{Persefone.Skylark, SimulationModel, String}","page":"Species models","title":"Persefone.destroynest!","text":"destroynest!(skylark, model, reason)\n\nRemove the skylark's nest and offspring due to disturbance or predation.\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.findterritory-Tuple{Persefone.Skylark, SimulationModel}","page":"Species models","title":"Persefone.findterritory","text":"findterritory(skylark, model)\n\nCheck whether the habitat surrounding the skylark is suitable for establishing a territory. If it is, return the list of coordinates that make up the new territory, else return an empty list.\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.foragequality-Tuple{Persefone.Skylark, SimulationModel, Tuple{Int64, Int64}}","page":"Species models","title":"Persefone.foragequality","text":"foragequality(skylark, model, pos)\n\nCalculate the relative quality of the habitat at this position for foraging. This assumes that open habitat is best (quality = 1.0), and steadily decreases as vegetation height and/or cover increase. (Linear regressions based on Püttmanns et al., 2021; Jeromin, 2002; Jenny, 1990b.)\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.matesearch-Tuple{Persefone.Skylark, SimulationModel}","page":"Species models","title":"Persefone.matesearch","text":"Females returning from migration move around to look for a suitable partner with a territory.\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.nesting-Tuple{Persefone.Skylark, SimulationModel}","page":"Species models","title":"Persefone.nesting","text":"Females that have found a partner build a nest and lay eggs in a suitable location.\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.nonbreeding-Tuple{Persefone.Skylark, SimulationModel}","page":"Species models","title":"Persefone.nonbreeding","text":"Non-breeding adults move around with other individuals and check for migration.\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.occupation-Tuple{Persefone.Skylark, SimulationModel}","page":"Species models","title":"Persefone.occupation","text":"Once a male has found a territory, he remains in it until the breeding season is over, adjusting it to new conditions when and as necessary.\n\n\n\n\n\n","category":"method"},{"location":"species.html#Persefone.territorysearch-Tuple{Persefone.Skylark, SimulationModel}","page":"Species models","title":"Persefone.territorysearch","text":"Males returning from migration move around to look for suitable habitats to establish a territory.\n\n\n\n\n\n","category":"method"},{"location":"species-dsl.html#Defining-new-species","page":"Defining new species","title":"Defining new species","text":"","category":"section"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"In order to make implementing new species as easy as possible, Persefone includes a domain-specific language (DSL) built from a collection of macros and functions.","category":"page"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"Here is an example of what this looks like, using a hypothetical mermaid species:","category":"page"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"@species Mermaid begin\n    ageofmaturity = 2\n    pesticidemortality = 1.0\nend\n\n@create Mermaid begin\n    @debug \"Created $(animalid(self)).\"\nend\n\n@phase Mermaid life begin\n    @debug \"$(animalid(self)) is swimming happily in its pond.\"\n    @respond pesticide @kill(self.pesticidemortality, \"poisoning\")\n    @respond harvesting @setphase(drought)\n    if self.sex == female && length(@neighbours()) < 3 &&\n        self.age >= self.ageofmaturity && @landcover() == water\n        @reproduce()\n    end\nend\n\n@phase Mermaid drought begin\n    n = sum(1 for a in @neighbours())\n    @debug \"$(animalid(self)) is experiencing drought with $n neighbour(s).\"\n    @respond sowing @setphase(life)\nend\n\n@populate Mermaid begin\n    birthphase = life\n    initphase = life\n    habitat = @habitat(@landcover() == water)\n    pairs=true\nend","category":"page"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"A complete species definition consists of one call each to @species, @create, @populate, and one or more calls to @phase. Another important macro is @habitat. Further macros are available to provide convenience wrappers for common functions.  (See src/nature/nature.jl for details.)","category":"page"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"The first macro to call is @species. This takes two arguments: a species  name and a definition block (enclosed in begin and end tags). Within the block, species-specific parameters and variables can be defined (and optionally given values) that should be available throughout a species' lifetime. ","category":"page"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"Next, each species must define one or more @phase blocks. The concept behind this is that species show different behaviours at different phases of their lifecycle. Each @phase block defines the behaviour in one of these phases. (Technically, it defines a function that will be called daily, so long as the species' phase variable is set to this phase.) Code in this section  has access to the model object as well as a self object, which is the  currently active Animal agent. Within a phase block, @respond  can be used to define the species' response to a FarmEvent that affects  the species' current location, while a variety of other macros provide wrappers to  life history and movement functions from src/nature/populations.jl.","category":"page"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"The third macro to call is @create. Like @phase, this defines a function with access to the world and self objects. This function is called whenever a new  individual of this species is created (either at birth, or when the model is initialised).","category":"page"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"The last macro that must be called is [@populate]. Whereas @create regulates the creation of individual animals, @populate determines how the population of a species is initialised at the start of a simulation. It does this by defining values for the parameters used by initpopulation!. The full list of parameters that can be used is documented under PopInitParams.","category":"page"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"The final important macro is @habitat. This defines a \"habitat descriptor\", i.e. a predicate function that tests whether or not a given landscape pixel is  suitable for a specified purpose. Such habitat descriptors are used as arguments to various functions, for example for population initialisation or movement. The argument to @habitat consists of a logical expression, which has access to the animal's current position (the pos tuple variable) and the model. Various macros are available to easily reference information about the current location, such as @landcover or @distancetoedge.","category":"page"},{"location":"species-dsl.html","page":"Defining new species","title":"Defining new species","text":"All of these macros are defined in src/nature/macros.jl.","category":"page"},{"location":"CHANGELOG.html#Changelog","page":"Changelog","title":"Changelog","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"All notable changes to this project will be documented in this file.","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","category":"page"},{"location":"CHANGELOG.html#[1.0.0]-in-planning","page":"Changelog","title":"[1.0.0] - in planning","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Aim: 4 species, 2 crop growth models, farm model, GAEC scenarios, experimental analysis","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Plan: decouple CairoMakie (#81), fix & test ALMaSS, set up first experiments","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Plan: add more regions","category":"page"},{"location":"CHANGELOG.html#[0.7.0]-unreleased","page":"Changelog","title":"[0.7.0] - unreleased","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Plan: allow for multiple crop models, AquaCrop crop model","category":"page"},{"location":"CHANGELOG.html#Added","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Add AquaCrop crop model\nAllow multiple crop models to be used in one simulation.  The settings \"crop.cropmodel\" and \"crop.cropdirectory\" are now comma-separated lists of crop models and their data directories.\nSimple linear crop height estimation for AquaCrop plants from biomass (AquaCrop does not model plant height)\nRead soil type map, controlled with the setting \"world.soiltypesmap\"\nLandscape Pixels store their soil type (enum SoilType)\nFarmPlots store the most common soil type of their landscape Pixels (AquaCrop needs the soil type as an input parameter).","category":"page"},{"location":"CHANGELOG.html#Changed","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html#Deprecated","page":"Changelog","title":"Deprecated","text":"","category":"section"},{"location":"CHANGELOG.html#Removed","page":"Changelog","title":"Removed","text":"","category":"section"},{"location":"CHANGELOG.html#Fixed","page":"Changelog","title":"Fixed","text":"","category":"section"},{"location":"CHANGELOG.html#[0.6.1]-14-03-2025","page":"Changelog","title":"[0.6.1] - 14-03-2025","text":"","category":"section"},{"location":"CHANGELOG.html#Added-2","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"user manual: documentation is now compiled to PDF (#91)\nadded soil maps to region data, but not used yet\nadded mean_cloud_cover and potential_evapotranspiration fields to weather data csv files","category":"page"},{"location":"CHANGELOG.html#Changed-2","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"added soil map section to GIS docs\nChanged weather internal representation to struct-of-arrays (previously a dict-of-struct representation).  The Weather type now stores all weather information for the whole simulation, with a function interface, e.g. sunshine(weather, date).\nWhen reading weather data, we now throw an error when there are missing days or any missing values for the fields min_temperature, max_temperature, mean_temperature, precipitation, and potential_evapotranspiration.  In the future missing values could also be imputed.\nThe script for weather data extraction at data/regions/auxiliary/extract_weather_data.R has been reworked to always return an output row for each day in the date range, even if the day is missing in the original data source.  It now also accepts the stations to download as command-line arguments.  The renv lockfile for the R environment used to run the script can be found at data/regions/auxiliary/renv.lock.","category":"page"},{"location":"CHANGELOG.html#Deprecated-2","page":"Changelog","title":"Deprecated","text":"","category":"section"},{"location":"CHANGELOG.html#Removed-2","page":"Changelog","title":"Removed","text":"","category":"section"},{"location":"CHANGELOG.html#Fixed-2","page":"Changelog","title":"Fixed","text":"","category":"section"},{"location":"CHANGELOG.html#[0.6.0]-13-01-2025","page":"Changelog","title":"[0.6.0] - 13-01-2025","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"This point release re-implements the ALMaSS crop model","category":"page"},{"location":"CHANGELOG.html#Added-3","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"crop.cropdirectory parameter specifies folder in which all crop data files for the selected crop model can be found.","category":"page"},{"location":"CHANGELOG.html#Changed-3","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"preprocessparameters() checks whether the map and crop directories are reachable from the  current working directory. If not, it checks whether it can be reached from the package directory.  This makes running simulations easier when Persefone has been installed as a package.\nsimulate() and initialise() now take a params keyword argument that can be used to override parameters from other input sources\nThe ALMaSS crop data config file data/crops/almass/crop_data_general.csv now has extra columns for is_c4_plant, sowingdensity, and phase_before_harvest","category":"page"},{"location":"CHANGELOG.html#Deprecated-3","page":"Changelog","title":"Deprecated","text":"","category":"section"},{"location":"CHANGELOG.html#Removed-3","page":"Changelog","title":"Removed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"crop.cropfile and crop.growthfile parameters -> user configuration is now done via crop.cropdirectory, names of ALMaSS input files are specified as constants in almass.jl","category":"page"},{"location":"CHANGELOG.html#Fixed-3","page":"Changelog","title":"Fixed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"The implementation of the ALMaSS vegetation model in Persefone has been completely rewritten, hopefully more faithfully reproducing the logic in ALMaSS.  The resulting plant heights are now more realistic and do not produce the extreme plant heights seen previously (which was due to an erroneous interpretation of the ALMaSS growth curves).","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"","category":"page"},{"location":"CHANGELOG.html#[0.5.5]-09-08-2024","page":"Changelog","title":"[0.5.5] - 09-08-2024","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"This point release implements the first basic farm model","category":"page"},{"location":"CHANGELOG.html#Added-4","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"basic farm model that assigns a crop rotation to each field, sowing and harvesting when appropriate\nnew parameters: farm.farmmodel, farm.setaside, farm.fieldoutfreq\nvisualisation of cropped area and crop growth over time\nfarm.setaside setting to configure what proportion of land farmers let lie fallow\nisharvestable() function for FarmPlots\n@areaof macro to calculate the area of a given number of landscape pixels\ndata/farm/standard_gross_margins.csv from KTBL data","category":"page"},{"location":"CHANGELOG.html#Changed-4","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"expanded & adapted general crop data and crop growth curve tables","category":"page"},{"location":"CHANGELOG.html#Fixed-4","page":"Changelog","title":"Fixed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"bug fixes in the ALMaSS crop model","category":"page"},{"location":"CHANGELOG.html#[0.5.4]-08-08-2024","page":"Changelog","title":"[0.5.4] - 08-08-2024","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Skylark data analysis and new internal utility functions","category":"page"},{"location":"CHANGELOG.html#Added-5","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"AnnualDate type and associated functions for working with recurring dates (#101)\ncan be constructed from two Int64, a Date, or a Tuple{Int64,Int64}\nautomatic conversion from Date or Tuple{Int64,Int64}\ncan use operators: ==, <, +, -, :\nthisyear(), lastyear(), nextyear() functions and macros\nnew file core/utils.jl for utility functions that fit in no other file\nirregular data logging using record!()/@record() (#103)\ndata outputs & visualisation for the skylark model (#97)\nrandn() function and macro to sample from a vector using a normal distribution\nmake install to download and install Julia and package dependencies (on Linux, #67)\nweather file for the Thüringer Becken","category":"page"},{"location":"CHANGELOG.html#Changed-5","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"moved random number functions and macros from input.jl to utils.jl\nexpanded weather data for Jena to 1990-2023\nNon-breeding skylarks only search for neighbours to follow once (-> huge performance improvement!)","category":"page"},{"location":"CHANGELOG.html#Fixed-5","page":"Changelog","title":"Fixed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"bug fixes in the skylark model","category":"page"},{"location":"CHANGELOG.html#[0.5.3]-31-07-2024","page":"Changelog","title":"[0.5.3] - 31-07-2024","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Switchable crop models","category":"page"},{"location":"CHANGELOG.html#Added-6","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Support for switchable crop models (#70), crop models can be set with the cropmodel setting in the [crop] section of parameters.toml.\nNew submodules ALMaSS for the ALMaSS crop model, and SimpleCrop for testing switchable crop models.","category":"page"},{"location":"CHANGELOG.html#Changed-6","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"All functionality specific to the ALMaSS crop model has been moved to the submodule ALMaSS.\nDue to switchable crop models, some types are now parametric: AgricultureModel{Tcroptype,Tcropstate} and FarmPlot{Tcropstate}.\nFarmPlot{Tcropstate} now only stores basic information about which pixels are part of the farm plot, all crop-specific information is now stored in the field cropstate.  Many functions acting on a FarmPlot now mostly forward to functions of the same name acting on the cropstate field of a FarmPlot.\nThe type of height in ALMaSS.CropState and ALMaSS.CropCurveParams is now a unitful number ::Length{Float64}.\nBoth crop models ALMaSS and SimpleCrop now also support the functions cropcover and cropyield in addition to croptype, cropname, cropheight.\ncropheight now returns a unitful number ::Length{Float64}, and returns height 0cm if the landscape at that position is not a FarmPlot.","category":"page"},{"location":"CHANGELOG.html#[0.5.2]-30-07-2024","page":"Changelog","title":"[0.5.2] - 30-07-2024","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Rewrote the skylark model","category":"page"},{"location":"CHANGELOG.html#Added-7","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Skylark model is largely rewritten to follow a new phase structure (#9)\nanimals can occupy territories (see @occupy, @isoccupied, @vacate macros/functions) (#94)\n@cropcover macro and function\nODD documentation for Skylark","category":"page"},{"location":"CHANGELOG.html#Changed-7","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"input files that are now copied to a separate inputs directory within the output directory\nEventType renamed to Management for clarity\ndocumentation website now has a \"Scientific Documentation\" section","category":"page"},{"location":"CHANGELOG.html#Removed-4","page":"Changelog","title":"Removed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"old skylark model (has been rewritten, see above)","category":"page"},{"location":"CHANGELOG.html#Fixed-6","page":"Changelog","title":"Fixed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"all skylarks now migrate (#90)\ninsectbiomass() uses units","category":"page"},{"location":"CHANGELOG.html#[0.5.1]-13-06-2024","page":"Changelog","title":"[0.5.1] - 13-06-2024","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Added Unitful.jl","category":"page"},{"location":"CHANGELOG.html#Added-8","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Unitful.jl now used to add units to quantities\nworld.mapdirectory parameter specifies the path to the directory in which","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"landcovermap, farmfieldsmap, and weatherfile are located","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"world.mapresolution parameter specifies the input maps' spatial resolution in meters","category":"page"},{"location":"CHANGELOG.html#Changed-8","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"spatial functions now work with explicit distances (using Unitful.jl) rather than using the number of pixels\nall species definitions and tests updated to use units","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"","category":"page"},{"location":"CHANGELOG.html#[0.5.0]-07-06-2024","page":"Changelog","title":"[0.5.0] - 07-06-2024","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"This release doesn't add much new functionality, but represents a major restructuring  of the code base. Specifically, it removes the Agents.jl dependency and changes the  way the species definition macros work and are used.","category":"page"},{"location":"CHANGELOG.html#Added-9","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"SimulationModel type, extended by AgricultureModel struct\n@create macro defines a special phase function that is called when an individual animal is created (at birth or on model initialisation)\nfunctions (and associated macros) to replace Agents.jl functionality:\nmove!() and walk!() \nnearby_ids(), nearby_animals(), countanimals(), neighbours()\ndirectionto(), distanceto(), randomdirection()\nnagents(), killallanimals!()\n@here macro to return the pixel currently occupied by the active animal\ncore.logoutput parameter to define whether logs are printed to screen, file, none, or both\nlarge logo and model structure diagram\nChangelog","category":"page"},{"location":"CHANGELOG.html#Changed-9","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"SimulationModel replaces AgentBasedModel\nSpecies definition macros revamped:\n@species now only defines parameters and variables and creates a mutable struct\n@phase must now be defined in the top-level code and creates a global function\n@initialise renamed to @populate, must also be called in the top-level code\ninitindividual() renamed to create!()\nSkylark, Wolpertinger, and Wyvern updated to match the new macros\nrequires Julia 1.10","category":"page"},{"location":"CHANGELOG.html#Removed-5","page":"Changelog","title":"Removed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Agents.jl dependency (including AgentBasedModel and functions for adding/moving/removing agents)","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"","category":"page"},{"location":"CHANGELOG.html#[0.4.1]-2023-11-14","page":"Changelog","title":"[0.4.1] - 2023-11-14","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Initial version of the skylark model","category":"page"},{"location":"CHANGELOG.html#Added-10","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"initial version of the Skylark species\nsmall Jena map\nanimal individuals keep track of their parents' IDs\nseveral new functions and macros for animals\ninstallation instructions for Windows","category":"page"},{"location":"CHANGELOG.html#Changed-10","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"graphics output is more configurable","category":"page"},{"location":"CHANGELOG.html#[0.4.0]-2023-10-28","page":"Changelog","title":"[0.4.0] - 2023-10-28","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Functions for animal populations","category":"page"},{"location":"CHANGELOG.html#Added-11","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"initialisation functions for individuals (not just species)\nmigration function / migrant pool for animals that disappear from the landscape during winter\nskylark migration","category":"page"},{"location":"CHANGELOG.html#Changed-11","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"online documentation was expanded and restructured\nnature macros moved to a separate file","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"Started changelog at this point, earlier versions are not included.","category":"page"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"<!– Template","category":"page"},{"location":"CHANGELOG.html#[version]-unreleased","page":"Changelog","title":"[version] - unreleased","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"<comments>","category":"page"},{"location":"CHANGELOG.html#*PLANNED*","page":"Changelog","title":"PLANNED","text":"","category":"section"},{"location":"CHANGELOG.html#Added-12","page":"Changelog","title":"Added","text":"","category":"section"},{"location":"CHANGELOG.html#Changed-12","page":"Changelog","title":"Changed","text":"","category":"section"},{"location":"CHANGELOG.html#Deprecated-4","page":"Changelog","title":"Deprecated","text":"","category":"section"},{"location":"CHANGELOG.html#Removed-6","page":"Changelog","title":"Removed","text":"","category":"section"},{"location":"CHANGELOG.html#Fixed-7","page":"Changelog","title":"Fixed","text":"","category":"section"},{"location":"CHANGELOG.html","page":"Changelog","title":"Changelog","text":"–>","category":"page"},{"location":"developing.html#Developing-Persefone","page":"Developing Persefone","title":"Developing Persefone","text":"","category":"section"},{"location":"developing.html#Setting-up","page":"Developing Persefone","title":"Setting up","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"If you haven't worked with Julia before, here are detailed instructions for how to set up your development environment. The main development is currently done on Linux (and as the primary execution platform will be an HPC, Linux compatibility is important), but developing on Windows works too.","category":"page"},{"location":"developing.html#Visual-Studio-Code-on-Windows","page":"Developing Persefone","title":"Visual Studio Code on Windows","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"Download and install Julia,  git and Visual Studio Code.\nInstall the Julia extension for VS Code: In VS Code, open the extensions pane (Ctrl+Shift+X). Search for and install Julia Language Support.\nClone the Gitlab repository: In VS Code, open the source control pane (Ctrl+Shift+G). Click on Clone and enter the repo URL. Then select a folder on your computer to download the files into, and let VS Code open the project once it has been cloned.\nStart a Julia REPL: In VS Code, bring up the command palette (Ctrl+Shift+P). Execute the command Julia: Start REPL. Then install all dependencies of Persefone by running using Pkg; Pkg.activate(\".\"); Pkg.instantiate(). (This will take some time.)\nOpen the file run.jl and click Execute (triangular button in the top right). The source code will compile (this can take a lot of time the first time you do it) and run a default simulation.\nFurther steps: You may want to familiarise yourself with how to use  git with VS Code. You may also want to clone the Persefone Desktop repository (repeat steps 3 to 5).","category":"page"},{"location":"developing.html#Emacs-on-Linux","page":"Developing Persefone","title":"Emacs on Linux","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"You can of course also use VS Code on Linux. In that case, follow the instructions above.","category":"page"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"Make sure you have git and Julia installed. Git should be in your distro's repos (e.g. sudo apt install git). To install Julia, download the binary and unpack it. For greater ease of use, copy the unpacked files to /usr/local/lib/julia (or similar) and create a symlink to the executable: sudo ln -s /usr/local/lib/julia/bin/julia /usr/local/bin/julia. Then go the to folder that you want to use for development and run  git clone https://git.idiv.de/persefone/persefone-model.git . in your terminal.","category":"page"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"There are a couple of addons that make working with Julia much nicer in Emacs:","category":"page"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"julia-mode gives syntax highlighting. Install with M-x package-install julia-mode.\njulia-snail provides IDE-like features,  especially a fully-functional REPL and the ability to evaluate code straight from inside a buffer. Note that the installation can be somewhat tricky. You first need to manually install all the dependencies of its dependency vterm, then install vterm itself with M-x package-install vterm, before you can do M-x package-install julia-snail. Then add it to your init.el with (require 'julia-snail) and (add-hook 'julia-mode-hook #'julia-snail-mode).\ncompany-mode integrates with Snail to give code  completion. Install with M-x package-install company, then add  (add-hook 'julia-mode-hook #'company-mode) and  (global-set-key (kbd \"C-<tab>\") 'company-complete) to your init.el.\nmagit is a great git interface for Emacs. Install with M-x package-install magit and add (global-set-key (kbd \"C-x g\") 'magit-status) to your init.el.","category":"page"},{"location":"developing.html#Development-workflow","page":"Developing Persefone","title":"Development workflow","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"Pull the current version from the master branch on Gitlab:  https://git.idiv.de/persefone/persefone-model.\nIf you are working on a new feature, create a new branch to avoid breaking the master branch. (The master branch on Github should always be in a runnable and error-free state.)\nImplement your changes.\nRun an example simulation and the test suite to make sure everything works without crashing (make run and make test on Linux, or execute run.jl and test/runtests.jl manually.)\nCommit your work frequently, and try to keep each commit small. Don't forget to add relevant tests to the test suite.\nOnce your satisfied with your work, do another pull/merge from the master branch in case somebody else changed the branch in the meantime. Then merge your work into master and push to the Gitlab server.\nRepeat :-)","category":"page"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"The Gitlab issue tracker  can be used to create, discuss, and assign tasks, as well as to monitor progress towards  milestones/releases. Once we have a first release, we will start using  semantic versioning and a changelog.","category":"page"},{"location":"developing.html#Important-libraries","page":"Developing Persefone","title":"Important libraries","text":"","category":"section"},{"location":"developing.html#Revise.jl","page":"Developing Persefone","title":"Revise.jl","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"Revise.jl allows one to reload code without restarting the Julia interpreter. Get it with Pkg.add(\"Revise\"), then  add using Revise to .julia/config/startup.jl to have it automatically available.","category":"page"},{"location":"developing.html#Test","page":"Developing Persefone","title":"Test","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"Persefone uses the inbuilt Julia testing framework. All new functions should have appropriate tests written for them in the appropriate file in the test directory. (See test/runtests.jl for details.) There are three ways to run the test suite: in the terminal, executing make test or cd test; julia runtests.jl; or in the Julia REPL,  Pkg.activate(\".\"); Pkg.test().","category":"page"},{"location":"developing.html#Documenter.jl","page":"Developing Persefone","title":"Documenter.jl","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"The HTML documentation is generated using Documenter.jl. Therefore, all new functions should have docstrings attached. New files need to be integrated into the relevant documentation source files in docs/src, and if necessary into docs/builddocs.jl. To build the documentation, run make docs, or cd docs; julia builddocs.jl (if using the latter, don't forget to update the date and commit in docs/src/index.md).","category":"page"},{"location":"developing.html#Graphics-and-user-interface","page":"Developing Persefone","title":"Graphics and user interface","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"Persefone uses Makie as a plotting library to generate its output graphics. Additionally, Persefone Desktop uses  QML.jl to create its graphical user interface.","category":"page"},{"location":"developing.html#Unitful.jl","page":"Developing Persefone","title":"Unitful.jl","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"Throughout the source code, variables can be tagged with their appropriate units using the Unitful.jl library. This makes the code easier to understand, and also allows automatic unit conversion:","category":"page"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"julia> 1ha == 10000m²\ntrue\n\njulia> 2km |> m\n2000 m\n\njulia> 2km / 10m\n200.0","category":"page"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"Within Persefone, the following units and dimensions have been imported for direct usage: cm, m, km, m², ha, km², mg, g, kg, Length, Area, Mass.","category":"page"},{"location":"developing.html#Dates","page":"Developing Persefone","title":"Dates","text":"","category":"section"},{"location":"developing.html","page":"Developing Persefone","title":"Developing Persefone","text":"Persefone expands the default Dates library with the AnnualDate type, which can be used to store dates that recur every year (e.g. migration or harvest). AnnualDates can be compared and added/subtracted just as normal dates. Use thisyear() to convert an AnnualDate to a Date.","category":"page"},{"location":"simulation.html#Simulation","page":"Simulation","title":"Simulation","text":"","category":"section"},{"location":"simulation.html","page":"Simulation","title":"Simulation","text":"The core and world directories hold source files that are important for all submodels,  including scheduling, landscape, weather, and input/output functions.","category":"page"},{"location":"simulation.html#Persefone.jl","page":"Simulation","title":"Persefone.jl","text":"","category":"section"},{"location":"simulation.html","page":"Simulation","title":"Simulation","text":"This file defines the module, including all exported symbols and two high-level types.","category":"page"},{"location":"simulation.html","page":"Simulation","title":"Simulation","text":"Modules = [Persefone]\nPages = [\"Persefone.jl\", \"core/utils.jl\"]","category":"page"},{"location":"simulation.html#Persefone.AbstractCropState","page":"Simulation","title":"Persefone.AbstractCropState","text":"AbstractCropState\n\nThe abstract supertype of all crop states in the model.  Each crop model has to define a type CropState <: AbstractCropState.\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.AbstractCropType","page":"Simulation","title":"Persefone.AbstractCropType","text":"AbstractCropType\n\nThe abstract supertype of all crop types in the model.  Each crop model has to define a type CropType <: AbstractCropType.\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.ModelAgent","page":"Simulation","title":"Persefone.ModelAgent","text":"ModelAgent\n\nThe supertype of all agents in the model (animal species, farmer types, farmplots).\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.SimulationModel","page":"Simulation","title":"Persefone.SimulationModel","text":"SimulationModel\n\nThe supertype of AgricultureModel. This is needed to avoid circular dependencies (most types and functions depend on SimulationModel, but the definition of the model struct depends on these types).\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.AnnualDate","page":"Simulation","title":"Persefone.AnnualDate","text":"AnnualDate\n\nA type to handle recurring dates (e.g. migration, harvest). Stores a month and a day, and can be compared against normal dates. To save typing, a Tuple{Int64,Int64} is automatically converted to an AnnualDate, allowing this syntax: nestingend::AnnualDate = (August, 15).\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Base.randn","page":"Simulation","title":"Base.randn","text":"randn(vector)\n\nReturn a random element from the given vector, following a (mostly) normal distribution based on index values (i.e. elements in the middle of the vector will be returned most frequently).\n\n\n\n\n\n","category":"function"},{"location":"simulation.html#Persefone.bounds-Tuple{Number}","page":"Simulation","title":"Persefone.bounds","text":"bounds(x; max=Inf, min=0)\n\nA utility function to make sure that a number is within a given set of bounds. Returns max/min if x is greater/less than this.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.cycle!","page":"Simulation","title":"Persefone.cycle!","text":"cycle!(vector, n=1)\n\nMove the first element of the vector to the end, repeat n times.\n\n\n\n\n\n","category":"function"},{"location":"simulation.html#Persefone.thisyear-Tuple{AnnualDate, SimulationModel}","page":"Simulation","title":"Persefone.thisyear","text":"thisyear(annualdate, model)\nnextyear(annualdate, model)\nlastyear(annualdate, model)\n\nConvert an AnnualDate to a Date, using the current/next/previous year of the simulation run.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.@areaof-Tuple{Any}","page":"Simulation","title":"Persefone.@areaof","text":"@areaof(npixels)\n\nCalculate the area of a given number of landscape pixels, knowing the resolution of the world map (requires the model object to be available).\n\n\n\n\n\n","category":"macro"},{"location":"simulation.html#Persefone.@chance-Tuple{Any}","page":"Simulation","title":"Persefone.@chance","text":"@chance(odds)\n\nReturn true if a random number is less than the odds (0.0 <= odds <= 1.0), using the model RNG. This is a utility wrapper that can only be used a context where the model object is available.\n\n\n\n\n\n","category":"macro"},{"location":"simulation.html#Persefone.@rand-Tuple","page":"Simulation","title":"Persefone.@rand","text":"@rand(args...)\n\nReturn a random number or element from the sample, using the model RNG. This is a utility wrapper that can only be used a context where the model object is available.\n\n\n\n\n\n","category":"macro"},{"location":"simulation.html#Persefone.@randn-Tuple{Any}","page":"Simulation","title":"Persefone.@randn","text":"@randn(vector)\n\nReturn a normally-distributed random number or element from the sample, using the model RNG. This is a utility wrapper that can only be used a context where the model object is available.\n\n\n\n\n\n","category":"macro"},{"location":"simulation.html#Persefone.@shuffle!-Tuple{Any}","page":"Simulation","title":"Persefone.@shuffle!","text":"@shuffle!(collection)\n\nShuffle the given collection in place, using the model RNG. This is a utility wrapper that can only be used a context where the model object is available.\n\n\n\n\n\n","category":"macro"},{"location":"simulation.html#simulation.jl","page":"Simulation","title":"simulation.jl","text":"","category":"section"},{"location":"simulation.html","page":"Simulation","title":"Simulation","text":"This file includes the basal functions for initialising and running simulations.","category":"page"},{"location":"simulation.html","page":"Simulation","title":"Simulation","text":"Modules = [Persefone]\nPages = [\"core/simulation.jl\"]","category":"page"},{"location":"simulation.html#Persefone.AgricultureModel","page":"Simulation","title":"Persefone.AgricultureModel","text":"AgricultureModel\n\nThis is the heart of the model - a struct that holds all data and state for one simulation run. It is created by initialise and passed as input to most model functions.\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.finalise!-Tuple{SimulationModel}","page":"Simulation","title":"Persefone.finalise!","text":"finalise!(model)\n\nWrap up the simulation. Finalises and visualises output, then terminates.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.initialise-Tuple{}","page":"Simulation","title":"Persefone.initialise","text":"initialise(configfile=PARAMFILE, params=Dict())\n\nInitialise the model: read in parameters, create the output data directory, and instantiate the SimulationModel object(s). Optionally allows specifying the configuration file and overriding specific parameters. This returns a single model object, unless the config file contains multiple values for one or more parameters, in which case it creates a full-factorial simulation experiment and returns a vector of model objects.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.initmodel-Tuple{Dict{String, Any}}","page":"Simulation","title":"Persefone.initmodel","text":"initmodel(settings)\n\nInitialise a model object using a ready-made settings dict. This is a helper function for initialise().\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.nagents-Tuple{AgricultureModel}","page":"Simulation","title":"Persefone.nagents","text":"nagents(model)\n\nReturn the total number of agents in a model object.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.paramscan-Tuple{Dict{String, Any}, Vector{String}}","page":"Simulation","title":"Persefone.paramscan","text":"paramscan(settings)\n\nCreate a list of settings dicts, covering all possible parameter combinations given by the input settings (i.e. a full-factorial experiment). This is a helper function for initialise().\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.simulate!-Tuple{SimulationModel}","page":"Simulation","title":"Persefone.simulate!","text":"simulate!(model)\n\nCarry out a complete simulation run using a pre-initialised model object.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.simulate-Tuple{}","page":"Simulation","title":"Persefone.simulate","text":"simulate(configfile=PARAMFILE, params=Dict())\n\nInitialise one or more model objects and carry out a full simulation experiment, optionally specifying a configuration file and/or specific parameters.\n\nThis is the default way to run a Persefone simulation.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.stepagent!-Tuple{ModelAgent, SimulationModel}","page":"Simulation","title":"Persefone.stepagent!","text":"stepagent!(agent, model)\n\nAll agent types must define a stepagent!() method that will be called daily.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.stepsimulation!-Tuple{SimulationModel}","page":"Simulation","title":"Persefone.stepsimulation!","text":"stepsimulation!(model)\n\nExecute one update of the model.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#landscape.jl","page":"Simulation","title":"landscape.jl","text":"","category":"section"},{"location":"simulation.html","page":"Simulation","title":"Simulation","text":"This file manages the landscape maps that underlie the model.","category":"page"},{"location":"simulation.html","page":"Simulation","title":"Simulation","text":"Modules = [Persefone]\nPages = [\"world/landscape.jl\"]","category":"page"},{"location":"simulation.html#Persefone.df_soiltypes_bodenatlas","page":"Simulation","title":"Persefone.df_soiltypes_bodenatlas","text":"Bodenatlas soil type id, corresponding Persefone soil type, and numbers to Persefone SoilType enum and the original Bodenatlas description of the soil type\n\n\n\n\n\n","category":"constant"},{"location":"simulation.html#Persefone.soiltype_bodenatlas_to_persefone","page":"Simulation","title":"Persefone.soiltype_bodenatlas_to_persefone","text":"Map a Bodenatlas soil type integer to a Persefone SoilType enum\n\n\n\n\n\n","category":"constant"},{"location":"simulation.html#Persefone.FarmEvent","page":"Simulation","title":"Persefone.FarmEvent","text":"FarmEvent\n\nA data structure to define a landscape event, giving its type, spatial extent, and duration.\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.LandCover","page":"Simulation","title":"Persefone.LandCover","text":"The land cover classes encoded in the Mundialis Sentinel data.\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.Management","page":"Simulation","title":"Persefone.Management","text":"The types of management event that can be simulated\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.Pixel","page":"Simulation","title":"Persefone.Pixel","text":"Pixel\n\nA pixel is a simple data structure to combine land use and ownership information in a single object. The model landscape consists of a matrix of pixels. (Note: further landscape information may be added here in future.)\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.SoilType","page":"Simulation","title":"Persefone.SoilType","text":"The soil type of a Pixel or FarmPlot\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.createevent!","page":"Simulation","title":"Persefone.createevent!","text":"createevent!(model, pixels, name, duration=1)\n\nAdd a farm event to the specified pixels (a vector of position tuples) for a given duration.\n\n\n\n\n\n","category":"function"},{"location":"simulation.html#Persefone.directionto-Tuple{Tuple{Int64, Int64}, SimulationModel, Function}","page":"Simulation","title":"Persefone.directionto","text":"directionto(pos, model, habitatdescriptor)\n\nCalculate the direction from the given location to the closest location matching the habitat descriptor function. Returns a coordinate tuple (target - position), or nothing if no matching habitat is found. Caution: can be computationally expensive!\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.directionto-Tuple{Tuple{Int64, Int64}, SimulationModel, Persefone.LandCover}","page":"Simulation","title":"Persefone.directionto","text":"directionto(pos, model, habitattype)\n\nCalculate the direction from the given location to the closest habitat of the specified type. Returns a coordinate tuple (target - position), or nothing if no matching habitat is found. Caution: can be computationally expensive!\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.distanceto-Tuple{Tuple{Int64, Int64}, SimulationModel, Function}","page":"Simulation","title":"Persefone.distanceto","text":"distanceto(pos, model, habitatdescriptor)\n\nCalculate the distance from the given location to the closest location matching the habitat descriptor function. Caution: can be computationally expensive!\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.distanceto-Tuple{Tuple{Int64, Int64}, SimulationModel, Persefone.LandCover}","page":"Simulation","title":"Persefone.distanceto","text":"distanceto(pos, model, habitattype)\n\nCalculate the distance from the given location to the closest habitat of the specified type. Caution: can be computationally expensive!\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.distancetoedge-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Simulation","title":"Persefone.distancetoedge","text":"distancetoedge(pos, model)\n\nCalculate the distance from the given location to the closest neighbouring habitat. Caution: can be computationally expensive!\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.farmplot-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Simulation","title":"Persefone.farmplot","text":"farmplot(position, model)\n\nReturn the farm plot at this position, or nothing if there is none (utility wrapper).\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.inbounds-Tuple{Any, Any}","page":"Simulation","title":"Persefone.inbounds","text":"inbounds(pos, model)\n\nIs the given position within the bounds of the model landscape?\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.initlandscape-NTuple{4, String}","page":"Simulation","title":"Persefone.initlandscape","text":"initlandscape(directory, landcovermap, farmfieldsmap, soiltypesmap)\n\nInitialise the model landscape based on the map files specified in the configuration. Returns a matrix of pixels.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.landcover-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Simulation","title":"Persefone.landcover","text":"landcover(position, model)\n\nReturn the land cover class at this position (utility wrapper).\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.randomdirection-Tuple{SimulationModel, Union{Unitful.Quantity{T, 𝐋, U}, Unitful.Level{L, S, Unitful.Quantity{T, 𝐋, U}} where {L, S}} where {T, U}}","page":"Simulation","title":"Persefone.randomdirection","text":"randomdirection(model, distance)\n\nGet a random direction coordinate tuple within the specified distance.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.randompixel","page":"Simulation","title":"Persefone.randompixel","text":"randompixel(position, model, range, habitatdescriptor)\n\nFind a random pixel within a given range of the position that matches the habitatdescriptor (create this using @habitat).\n\n\n\n\n\n","category":"function"},{"location":"simulation.html#Persefone.safebounds-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Simulation","title":"Persefone.safebounds","text":"safebounds(pos, model)\n\nMake sure that a given position is within the bounds of the model landscape.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.updateevents!-Tuple{SimulationModel}","page":"Simulation","title":"Persefone.updateevents!","text":"updateevents!(model)\n\nCycle through the list of events, removing those that have expired.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#weather.jl","page":"Simulation","title":"weather.jl","text":"","category":"section"},{"location":"simulation.html","page":"Simulation","title":"Simulation","text":"This file reads in weather data and makes it available to the model.","category":"page"},{"location":"simulation.html","page":"Simulation","title":"Simulation","text":"Modules = [Persefone]\nPages = [\"world/weather.jl\"]","category":"page"},{"location":"simulation.html#Persefone.Weather","page":"Simulation","title":"Persefone.Weather","text":"Weather\n\nHolds the weather information for the whole simulation period.\n\n\n\n\n\n","category":"type"},{"location":"simulation.html#Persefone.check_missing_weatherdata-Tuple{DataFrames.DataFrame}","page":"Simulation","title":"Persefone.check_missing_weatherdata","text":"check_missing_weatherdata(dataframe)\n\nCheck the weather input data for missing values in columns where input values are required.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.daynumber-Tuple{Weather, Dates.Date}","page":"Simulation","title":"Persefone.daynumber","text":"daynumber(weather, date)\n\nReturns the number of days, counting weather.firstdate as day 1.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.evapotranspiration-Tuple{Weather, Dates.Date}","page":"Simulation","title":"Persefone.evapotranspiration","text":"evapotranspiration(weather, date)\n\nReturn today's potential evapotranspiration (ETo) on date.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.findspans-Tuple{Any, AbstractVector}","page":"Simulation","title":"Persefone.findspans","text":"findspans(predicate_fn, array) -> Vector{Tuple{Int, Int}}\n\nReturns spans of indices in a 1-d array where a predicate_fn returns true.  The spans are returned as a Vector{Tuple{Int, Int}}, where each tuple is of the form (start_index, end_index).\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.humidity-Tuple{Weather, Dates.Date}","page":"Simulation","title":"Persefone.humidity","text":"humidity(weather, date)\n\nReturn today's average vapour pressure in %.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.initweather-Tuple{String, Dates.Date, Dates.Date}","page":"Simulation","title":"Persefone.initweather","text":"initweather(weatherfile, startdate, enddate)\n\nLoad a weather file, extract the values that are relevant to this model run (specified by start and end dates), and return a dictionary of Weather objects mapped to dates.\n\nNote: This requires a weather file in the format produced by   data/regions/auxiliary/extract_weather_data.R.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.maxtemp-Tuple{Weather, Dates.Date}","page":"Simulation","title":"Persefone.maxtemp","text":"maxtemp(weather, date)\n\nReturn the maximum temperature in °C on date.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.meantemp-Tuple{Weather, Dates.Date}","page":"Simulation","title":"Persefone.meantemp","text":"meantemp(weather, date)\n\nReturn the mean temperature in °C on date.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.mintemp-Tuple{Weather, Dates.Date}","page":"Simulation","title":"Persefone.mintemp","text":"mintemp(weather, date)\n\nReturn the minimum temperature in °C on date.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.precipitation-Tuple{Weather, Dates.Date}","page":"Simulation","title":"Persefone.precipitation","text":"precipitation(weather, date)\n\nReturn the total precipitation in mm on date.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.sunshine-Tuple{Weather, Dates.Date}","page":"Simulation","title":"Persefone.sunshine","text":"sunshine(weather, date)\n\nReturn the sunshine duration in hours on date.\n\n\n\n\n\n","category":"method"},{"location":"simulation.html#Persefone.windspeed-Tuple{Weather, Dates.Date}","page":"Simulation","title":"Persefone.windspeed","text":"windspeed(weather, date)\n\nReturn the average windspeed in m/s on date.\n\n\n\n\n\n","category":"method"},{"location":"farm.html#Farm-submodel","page":"Farm submodel","title":"Farm submodel","text":"","category":"section"},{"location":"farm.html","page":"Farm submodel","title":"Farm submodel","text":"Eventually, the aim is to create a full socio-economic farm decision model for Persefone. However, for the time being, we will restrict ourselves to a simple model that executes typical farm operations and crop rotations.","category":"page"},{"location":"farm.html#farm.jl","page":"Farm submodel","title":"farm.jl","text":"","category":"section"},{"location":"farm.html","page":"Farm submodel","title":"Farm submodel","text":"This file is responsible for managing the farm module(s).","category":"page"},{"location":"farm.html","page":"Farm submodel","title":"Farm submodel","text":"Modules = [Persefone]\nPages = [\"farm/farm.jl\"]","category":"page"},{"location":"farm.html#Persefone.BasicFarmer","page":"Farm submodel","title":"Persefone.BasicFarmer","text":"BasicFarmer\n\nThe BasicFarmer type simply applies a set crop rotation to his fields and keeps track of income.\n\n\n\n\n\n","category":"type"},{"location":"farm.html#Persefone.Farmer","page":"Farm submodel","title":"Persefone.Farmer","text":"This is the agent type for the farm ABM.\n\n\n\n\n\n","category":"type"},{"location":"farm.html#Persefone.findsetasides-Tuple{Persefone.BasicFarmer, SimulationModel}","page":"Farm submodel","title":"Persefone.findsetasides","text":"findsetasides(farmer, model)\n\nReturn a vector of field IDs that this farmer should keep fallow to satisfy the configured set-aside rules.\n\n\n\n\n\n","category":"method"},{"location":"farm.html#Persefone.initbasicfarms!-Tuple{SimulationModel}","page":"Farm submodel","title":"Persefone.initbasicfarms!","text":"initbasicfarms!(model)\n\nInitialise the basic farm model. All fields are controlled by a single farmer actor and are assigned as grassland, set-aside, or arable land with a crop rotation.\n\n\n\n\n\n","category":"method"},{"location":"farm.html#Persefone.initfarms!-Tuple{SimulationModel}","page":"Farm submodel","title":"Persefone.initfarms!","text":"initfarms!(model)\n\nInitialise the model with a set of farm agents, depending on the configured farm model.\n\n\n\n\n\n","category":"method"},{"location":"farm.html#Persefone.stepagent!-Tuple{Persefone.BasicFarmer, SimulationModel}","page":"Farm submodel","title":"Persefone.stepagent!","text":"stepagent!(farmer, model)\n\nUpdate a farmer by one day. Cycle through all fields and see what management is needed.\n\n\n\n\n\n","category":"method"},{"location":"adapting.html#Adapting-Persefone","page":"Adapting Persefone","title":"Adapting Persefone","text":"","category":"section"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"A key development goal of Persefone is to be FAIR: findable, accessible, interoperable, and reusable. We aim to build a model that is both easy  to use and easy to adapt to new situations.","category":"page"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"There are multiple ways to adapt Persefone for a new modelling study:","category":"page"},{"location":"adapting.html#Changing-the-parameters","page":"Adapting Persefone","title":"Changing the parameters","text":"","category":"section"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"The simplest way to adapt Persefone is simply by changing the parameters. Copy src/parameters.toml to a new location, adjust it to your needs, and run the model using julia run.jl -c <configfile>.","category":"page"},{"location":"adapting.html#Changing-the-region","page":"Adapting Persefone","title":"Changing the region","text":"","category":"section"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"To apply Persefone to a new region, you need to create new input maps of land cover and farmplots. How to do so is described here.","category":"page"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"You may also need to change aspects of the farm submodel. This is not yet implemented.","category":"page"},{"location":"adapting.html#Adding-new-animal-species","page":"Adapting Persefone","title":"Adding new animal species","text":"","category":"section"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"To implement a new species to the nature submodel, add a new file to the  src/nature/species directory and include it in src/Persefone.jl, as well as adding the name of the species to the nature.targetspecies parameter. In the new file, implement the species using the @species syntax as described here.","category":"page"},{"location":"adapting.html#Adding-new-crop-species","page":"Adapting Persefone","title":"Adding new crop species","text":"","category":"section"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"Crop growth is not yet implemented.","category":"page"},{"location":"adapting.html#Adding-new-farmer-behaviour","page":"Adapting Persefone","title":"Adding new farmer behaviour","text":"","category":"section"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"Farmer behaviour is not yet implemented.","category":"page"},{"location":"adapting.html#Adding-a-new-submodel","page":"Adapting Persefone","title":"Adding a new submodel","text":"","category":"section"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"To add a new submodel in addition to the existing ones (nature, crop, and farm), you need to familiarise yourself with the software architecture. In particular, you need to understand how initialisation and scheduling works in src/core/simulation.jl, and what information is stored in the model object.","category":"page"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"If you want to add a new agent type, create a subtype of ModelAgent, implement a stepagent! function for it and add it to Persefone.initmodel.","category":"page"},{"location":"adapting.html#Linking-to-another-model","page":"Adapting Persefone","title":"Linking to another model","text":"","category":"section"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"Persefone can also be used as a software library and be called from another application. For this purpose, it is set up as a Julia package, with a module exporting various model functions, types, and macros (see  src/Persefone.jl). Of particular interest are the functions simulate (set up and run a complete simulation based on a config file), initialise (create one or more model objects from a config file), simulate! (do a simulation run with an existing model object), and stepsimulation! (update a model object by one time step).","category":"page"},{"location":"adapting.html","page":"Adapting Persefone","title":"Adapting Persefone","text":"To interface with Julia from another language, see the Julia docs here and here.","category":"page"},{"location":"crop-models.html#Crop-models","page":"Crop models","title":"Crop models","text":"","category":"section"},{"location":"crop-models.html","page":"Crop models","title":"Crop models","text":"TODO","category":"page"},{"location":"crop-models.html#ALMaSS","page":"Crop models","title":"ALMaSS","text":"","category":"section"},{"location":"crop-models.html#AquaCrop","page":"Crop models","title":"AquaCrop","text":"","category":"section"},{"location":"odd.html#Overview,-Design,-Details-(ODD)","page":"Overview, Design, Details (ODD)","title":"Overview, Design, Details (ODD)","text":"","category":"section"},{"location":"odd.html","page":"Overview, Design, Details (ODD)","title":"Overview, Design, Details (ODD)","text":"The  model  description follows  the  ODD  (Overview,  Design  concepts, Details)  protocol  (Grimm  et  al.,  2006; 2010; 2020):","category":"page"},{"location":"odd.html#1.-Purpose","page":"Overview, Design, Details (ODD)","title":"1. Purpose","text":"","category":"section"},{"location":"odd.html#2.-Entities,-state-variables,-and-scales","page":"Overview, Design, Details (ODD)","title":"2. Entities, state variables, and scales","text":"","category":"section"},{"location":"odd.html#3.-Process-overview-and-scheduling","page":"Overview, Design, Details (ODD)","title":"3. Process overview and scheduling","text":"","category":"section"},{"location":"odd.html#4.-Design-concepts","page":"Overview, Design, Details (ODD)","title":"4. Design concepts","text":"","category":"section"},{"location":"odd.html#4.1-Basic-principles","page":"Overview, Design, Details (ODD)","title":"4.1 Basic principles","text":"","category":"section"},{"location":"odd.html#4.2-Emergence","page":"Overview, Design, Details (ODD)","title":"4.2 Emergence","text":"","category":"section"},{"location":"odd.html#4.3-Adaptation","page":"Overview, Design, Details (ODD)","title":"4.3 Adaptation","text":"","category":"section"},{"location":"odd.html#4.4-Objectives","page":"Overview, Design, Details (ODD)","title":"4.4 Objectives","text":"","category":"section"},{"location":"odd.html#4.5-Learning","page":"Overview, Design, Details (ODD)","title":"4.5 Learning","text":"","category":"section"},{"location":"odd.html#4.6-Prediction","page":"Overview, Design, Details (ODD)","title":"4.6 Prediction","text":"","category":"section"},{"location":"odd.html#4.7-Sensing","page":"Overview, Design, Details (ODD)","title":"4.7 Sensing","text":"","category":"section"},{"location":"odd.html#4.8-Interaction","page":"Overview, Design, Details (ODD)","title":"4.8 Interaction","text":"","category":"section"},{"location":"odd.html#4.9-Stochasticity","page":"Overview, Design, Details (ODD)","title":"4.9 Stochasticity","text":"","category":"section"},{"location":"odd.html#4.10-Collectives","page":"Overview, Design, Details (ODD)","title":"4.10 Collectives","text":"","category":"section"},{"location":"odd.html#4.11-Observation","page":"Overview, Design, Details (ODD)","title":"4.11 Observation","text":"","category":"section"},{"location":"odd.html#5.-Initialisation","page":"Overview, Design, Details (ODD)","title":"5. Initialisation","text":"","category":"section"},{"location":"odd.html#6.-Input-data","page":"Overview, Design, Details (ODD)","title":"6. Input data","text":"","category":"section"},{"location":"odd.html#7.-Submodels","page":"Overview, Design, Details (ODD)","title":"7. Submodels","text":"","category":"section"},{"location":"odd.html#8.-References","page":"Overview, Design, Details (ODD)","title":"8. References","text":"","category":"section"},{"location":"gis.html#Maps-and-weather-data","page":"Maps and weather data","title":"Maps and weather data","text":"","category":"section"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"Persefone.jl requires three map input files: one for land cover, one for for field geometries, and one for soil types. Additionally, a weather input  file is needed. This documents describe how to obtain and process the data  needed for each of these.","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"There is a QGIS project file at data/regions/auxiliary/persefone.qgz, which can be used get an overview of the existing region input files and add new ones. All region data files are stored using the following convention:","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"data/regions/<regionname>/\n-> <regionname>.geojson\n-> landcover.tif\n-> fields.tif\n-> soil.tif\n-> weather.csv","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"Where <regionname> is currently one of bodensee, eichsfeld, hohenlohe, jena, oberrhein, or thueringer_becken.","category":"page"},{"location":"gis.html#Land-cover-maps","page":"Maps and weather data","title":"Land cover maps","text":"","category":"section"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"Land cover maps for Germany at 10m resolution can be obtained from  Mundialis. These are generated annually from Sentinel data and comprise the following  land cover classes:","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"10: forest\n20: low vegetation\n30: water\n40: built-up\n50: bare soil\n60: agriculture","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"To create a Persefone map input file, you need to crop the national Mundialis map to the extent that you want to simulate (suggestion: edge lengths between 10-20 km are a reasonable size).","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"To do so, download the Mundialis map and import it into QGIS. Then create a new vector layer and create a rectangle feature to delimit the extent of your region. You can save this as a GEOJSON file to the region folder for future reference.  Then go to Raster -> Extraction -> Clip Raster by Extent. Select the Mundialis map as the input layer, set the clipping extent by choosing your region vector layer under Calculate from Layer and specify the output file name before clicking Run. This will generate a TIF file that you can pass to Persefone as the landcovermap parameter.","category":"page"},{"location":"gis.html#Field-ID-maps","page":"Maps and weather data","title":"Field ID maps","text":"","category":"section"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"In addition to the land cover data explained above, Persefone also needs information about agricultural field boundaries in order to assign these to the farming agents. Unfortunately, getting this is rather more complicated.","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"In the EU, every country runs a Land Parcel Information System (LPIS) to administer CAP payments. In Germany, this is called InVeKoS and is run by the Länder. For example, you can view and download the InVeKoS data for  Thüringen or Baden-Württemberg. This gives you a vector layer which can be loaded into QGIS. However, it needs to be converted to a raster layer and cropped to your region extent before it can be used in Persefone.","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"The first thing to do is to make sure that the vector layer has a numeric (!) field with a unique identifier for each field block (check the attribute table).  The Thüringen data has the FBI (\"Feldblockident\") field, but this is a string value and therefore not usable by the rasteriser. So, we set the vector layer to edit mode, open the field calculator, enter the information for a new field  (call it \"FID\" and set it to a 32-bit integer), and enter @row_number in the  expression field. Then save the layer and close the calculator.","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"Secondly, you need to filter out all non-field/non-grassland plot types. (LPIS also has data on forests and various landscape elements that are not relevant to our use case.) Assuming you're working with the Thüringen InVeKoS data (other data sets may have a different structure), right-click on the layer name in QGIS' layer overview and click on \"Filter...\". Then, enter this expression in the query builder: \"BNK\" = 'AL' OR \"BNK\" = 'GL' and click \"OK\". This will select only field and grassland plots.","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"Next, open the rasteriser (Raster -> Conversion -> Rasterize). Select your FID field as the \"Field to use for a burn-in value\", and your land cover map (as created above - this ensures the two layers match) as the output extent. Make sure  the \"fixed value to burn\" is \"Not set\". Then choose \"Georeferenced units\" as the  \"Out raster size units\" and set horizontal and vertical resolution to 10.0. In  the advanced parameters, set the output data type to UInt32. Finally, enter an  output file name and run. The resulting TIF file can be passed to Persefone as the farmfieldmap parameter.","category":"page"},{"location":"gis.html#Soil-data","page":"Maps and weather data","title":"Soil data","text":"","category":"section"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"Soil data for Germany is provided by the Bundesanstalt für Geowissenschaften und Rohstoffe in form of the Bodenatlas. This provides a (coarse, but for our purposes sufficient) map of the distribution of the basic soil types such as clay, silt, sand, and loam.","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"To create the Persefone input file, you first need to rasterise the data. See the instructions above - choose BODENART as the field for the burn-in value. (Note: rastering the whole map produces a 20GB file! This can later be deleted again.) Then you need to align and crop it to the extent you require, using the dialog at  Raster -> Align Rasters.... Select your landcover map as the reference layer and the extent layer, then choose your national soil map as the input. (Don't forget to define the output file name using Configure Raster..., this is a bit hidden.) The created output file can then be used for the soilmap parameter. Its integer values map onto the SoilType enum as follows:","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"1: Abbauflächen -> nosoil\n2: Gewässer -> nosoil\n3: Lehmsande (ls) -> loamy_sand\n4: Lehmschluffe (lu) -> silt_loam\n5: Moore -> nosoil\n6: Normallehme (ll) -> loam\n7: Reinsande (ss) -> sand\n8: Sandlehme (sl) -> sandy_loam\n9: Schluffsande (us) -> sandy_loam\n10: Schlufftone (ut) -> silty_clay\n11: Siedlung -> nosoil\n12: Tonlehme (tl) -> clay_loam\n13: Tonschluffe (tu) -> silty_clay_loam\n14: Watt -> nosoil","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"(Image: Soil types triangle)","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"Names of soil types are based on the relative composition of clay, silt, and sand. Note that the typology used in the Bodenatlas does not map perfectly on to this international classification. Image source: Australian Environmental Education","category":"page"},{"location":"gis.html#Weather-data","page":"Maps and weather data","title":"Weather data","text":"","category":"section"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"Currently, Persefone uses historical weather data from the closest weather station as its weather input. (In future, this may be changed to a more detailed raster input, which could then also provide future weather predictions under climate change.) Weather data can be downloaded from the German weather service (DWD).","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"The description of these data sets and the list of weather stations can be found in the Persefone repository, in the docs folder (or downloaded from the link above). Using the list of weather stations, select the one closest to the area of study. Note that not all stations were continuously in operation; make sure that the selected station covers the years of interest. The currently included regions have the following station codes:","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"Region Jena: station number 02444 (\"Jena (Sternwarte)\")\nRegion Eichsfeld: station number 02925 (\"Leinefelde\") \nRegion Thüringer Becken: station number 00896 (\"Dachwig\")\nRegion Hohenlohe: station number 03761 (\"Oehringen\")\nRegion Bodensee: station number 06263 (\"Singen\")\nRegion Nördlicher Oberrhein: station number 05275 (\"Waghäusel-Kirrlach\")","category":"page"},{"location":"gis.html","page":"Maps and weather data","title":"Maps and weather data","text":"The script data/regions/auxiliary/extract_weather_data.R can be used to download and process the data into the format needed by Persefone. This uses the rdwd package. To use it, simply specify the  desired region, adding its ID to the stationid list if necessary. The produced CSV file can be copied into the respective region folder.","category":"page"},{"location":"crops.html#Crop-submodel","page":"Crop submodel","title":"Crop submodel","text":"","category":"section"},{"location":"crops.html","page":"Crop submodel","title":"Crop submodel","text":"Eventually, the plan is to have Persefone include a reimplementation of the AquaCrop model,  a well-established crop growth model developed by the FAO. Until then, we are using the crop growth submodel used in ALMaSS.","category":"page"},{"location":"crops.html#farmplot.jl","page":"Crop submodel","title":"farmplot.jl","text":"","category":"section"},{"location":"crops.html","page":"Crop submodel","title":"Crop submodel","text":"This file is responsible for the farm plots, i.e. the indidivual fields that farmers manage.","category":"page"},{"location":"crops.html","page":"Crop submodel","title":"Crop submodel","text":"Modules = [Persefone]\nPages = [\"crop/farmplot.jl\"]","category":"page"},{"location":"crops.html#Persefone.FarmPlot","page":"Crop submodel","title":"Persefone.FarmPlot","text":"FarmPlot\n\nA struct representing a single field, on which a crop can be grown.\n\n\n\n\n\n","category":"type"},{"location":"crops.html#Persefone.averagefieldsize-Tuple{SimulationModel}","page":"Crop submodel","title":"Persefone.averagefieldsize","text":"averagefieldsize(model)\n\nCalculate the average field size in hectares for the model landscape.\n\n\n\n\n\n","category":"method"},{"location":"crops.html#Persefone.cropcover-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Crop submodel","title":"Persefone.cropcover","text":"cropcover(model, position)\n\nReturn the crop cover of the crop at this position, or nothing if there is no crop here (utility wrapper).\n\n\n\n\n\n","category":"method"},{"location":"crops.html#Persefone.cropheight-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Crop submodel","title":"Persefone.cropheight","text":"cropheight(model, position)\n\nReturn the height of the crop at this position, or nothing if there is no crop here (utility wrapper).\n\n\n\n\n\n","category":"method"},{"location":"crops.html#Persefone.cropname-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Crop submodel","title":"Persefone.cropname","text":"cropname(model, position)\n\nReturn the name of the crop at this position, or an empty string if there is no crop here (utility wrapper).\n\n\n\n\n\n","category":"method"},{"location":"crops.html#Persefone.croptype-Tuple{Tuple{Int64, Int64}, SimulationModel}","page":"Crop submodel","title":"Persefone.croptype","text":"croptype(model, position)\n\nReturn the crop at this position, or nothing if there is no crop here (utility wrapper).\n\n\n\n\n\n","category":"method"},{"location":"crops.html#Persefone.harvest!-Tuple{FarmPlot, SimulationModel}","page":"Crop submodel","title":"Persefone.harvest!","text":"harvest!(farmplot, model)\n\nHarvest the crop of this farmplot.\n\n\n\n\n\n","category":"method"},{"location":"crops.html#Persefone.isgrassland-Tuple{FarmPlot, SimulationModel}","page":"Crop submodel","title":"Persefone.isgrassland","text":"isgrassland(farmplot, model)\n\nClassify a farmplot as grassland or not (i.e., is the landcover of >80% of its pixels grass?)\n\n\n\n\n\n","category":"method"},{"location":"crops.html#Persefone.sow!-Tuple{FarmPlot, SimulationModel, String}","page":"Crop submodel","title":"Persefone.sow!","text":"sow!(farmplot, model, cropname)\n\nSow the specified crop on the farmplot.\n\n\n\n\n\n","category":"method"},{"location":"crops.html#Persefone.stepagent!-Tuple{FarmPlot, SimulationModel}","page":"Crop submodel","title":"Persefone.stepagent!","text":"stepagent!(farmplot, model)\n\nUpdate a farm plot by one day.\n\n\n\n\n\n","category":"method"},{"location":"crops.html#Persefone.@harvest-Tuple{}","page":"Crop submodel","title":"Persefone.@harvest","text":"@harvest()\n\nHarvest the current field. Requires the variables field and model.\n\n\n\n\n\n","category":"macro"},{"location":"crops.html#Persefone.@sow-Tuple{Any}","page":"Crop submodel","title":"Persefone.@sow","text":"@sow(cropname)\n\nSow the named crop on the current field. Requires the variables field and model.\n\n\n\n\n\n","category":"macro"},{"location":"crops.html#crops.jl","page":"Crop submodel","title":"crops.jl","text":"","category":"section"},{"location":"crops.html","page":"Crop submodel","title":"Crop submodel","text":"This includes the types and functions needed for all crop growth model, which are also referenced by the other submodels.","category":"page"},{"location":"crops.html","page":"Crop submodel","title":"Crop submodel","text":"Modules = [Persefone]\nPages = [\"crop/crops.jl\"]","category":"page"},{"location":"management.html#Farm-management","page":"Farm management","title":"Farm management","text":"","category":"section"},{"location":"management.html","page":"Farm management","title":"Farm management","text":"TODO","category":"page"},{"location":"management.html#Crop-rotations-and-management","page":"Farm management","title":"Crop rotations and management","text":"","category":"section"},{"location":"management.html#Environmental-regulations","page":"Farm management","title":"Environmental regulations","text":"","category":"section"},{"location":"index.html","page":"Introduction","title":"Introduction","text":"CurrentModule = Persefone","category":"page"},{"location":"index.html#Introduction","page":"Introduction","title":"Introduction","text":"","category":"section"},{"location":"index.html","page":"Introduction","title":"Introduction","text":"(Image: Persefone.jl splash screen)","category":"page"},{"location":"index.html","page":"Introduction","title":"Introduction","text":"Persefone.jl models agricultural practice and how it impacts  animal species at a landscape scale. It includes a farm submodel, a crop growth submodel,  and individual-based models of multiple indicator species. Its aim is to investigate how  changes in farm operations (e.g. through policy changes in the CAP) influence biodiversity.","category":"page"},{"location":"index.html","page":"Introduction","title":"Introduction","text":"The model is open-source software available on  Gitlab.","category":"page"},{"location":"index.html","page":"Introduction","title":"Introduction","text":"This documentation was last updated on 2025-03-18 for Persefone.jl v0.7.0 (commit b1802d1).","category":"page"}]
}
